// BuildDialog.cpp : implementation file
//

#include "stdafx.h"
#include "quincy.h"
#include "OptionsSheet.h"
#include "BuildDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBuildDialog dialog


CBuildDialog::CBuildDialog(CWnd* pParent /*=NULL*/)
	: CPropertyPage(CBuildDialog::IDD)
{
	//{{AFX_DATA_INIT(CBuildDialog)
	m_bDebugging = FALSE;
	m_bExceptions = FALSE;
	m_bRTTI = FALSE;
	m_bStrict = FALSE;
	m_strDefine = _T("");
	m_strInclude = _T("");
	m_StdLibrary = -1;
	m_strLib = _T("");
	m_strCmdLineOptions = _T("");
	//}}AFX_DATA_INIT
	m_nOptimize = 0;
}


void CBuildDialog::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBuildDialog)
	DDX_Control(pDX, IDC_RTTI, m_RTTIbutton);
	DDX_Check(pDX, IDC_DEBUG, m_bDebugging);
	DDX_Check(pDX, IDC_EXCEPTIONS, m_bExceptions);
	DDX_Check(pDX, IDC_RTTI, m_bRTTI);
	DDX_Check(pDX, IDC_STRICT, m_bStrict);
	DDX_Text(pDX, IDC_DEFINE, m_strDefine);
	DDX_Text(pDX, IDC_INCLUDE, m_strInclude);
	DDX_Control(pDX, IDC_STDLIB1, m_StdLibraryButton);
	DDX_Radio(pDX, IDC_STDLIB1, m_StdLibrary);
	DDX_Text(pDX, IDC_LIB, m_strLib);
	DDX_Control(pDX, IDC_OPTIMIZE, m_Optimize);
	DDX_Control(pDX, IDC_OPTIMIZESPIN, m_OptimizeSpin);
	DDX_Text(pDX, IDC_CMDLINEOPTIONS, m_strCmdLineOptions);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBuildDialog, CPropertyPage)
	//{{AFX_MSG_MAP(CBuildDialog)
	ON_BN_CLICKED(IDC_DEBUG, OnDebug)
	ON_BN_CLICKED(IDC_EXCEPTIONS, OnExceptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBuildDialog message handlers
BOOL CBuildDialog::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	if (!m_bStdLibIsInstalled)	{
		m_StdLibraryButton.EnableWindow(FALSE);
		CWnd* pWnd = GetNextDlgGroupItem(&m_StdLibraryButton);
		pWnd->EnableWindow(FALSE);
		m_StdLibrary = 0;
	}
	m_OptimizeSpin.SetRange(0,theApp.UseBCC() ? 2 : 3);
	OnDebug();
	OnExceptions();
	return TRUE;
}

void CBuildDialog::OnDebug() 
{
	UpdateData();
	if (m_bDebugging)	{
		m_OptimizeSpin.SetPos(0);
		m_Optimize.EnableWindow(FALSE);
		m_OptimizeSpin.EnableWindow(FALSE);
	}
	else	{
		m_Optimize.EnableWindow();
		m_OptimizeSpin.EnableWindow();
		m_OptimizeSpin.SetPos(m_nOptimize);
	}
}

void CBuildDialog::OnExceptions() 
{
	UpdateData();
	if (m_bExceptions)	{
		m_RTTIbutton.SetCheck(1);
		m_RTTIbutton.EnableWindow(FALSE);
	}
	else
		m_RTTIbutton.EnableWindow();
}

void CBuildDialog::OnOK() 
{
	UpdateData();
	m_nOptimize = m_OptimizeSpin.GetPos();
	CPropertyPage::OnOK();
}

BOOL CBuildDialog::OnSetActive() 
{
	static_cast<COptionsSheet*>(GetParent())->RegisterActiveIndex();
	return CPropertyPage::OnSetActive();
}

