// SampleCode.cpp : implementation file
//

#include "stdafx.h"
#include "quincy.h"
#include "SampleCode.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSampleCode

CSampleCode::CSampleCode()
{
	m_tabstops = 4;
	m_syntaxcolor = TRUE;
}

CSampleCode::~CSampleCode()
{
}


BEGIN_MESSAGE_MAP(CSampleCode, CEdit)
	//{{AFX_MSG_MAP(CSampleCode)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleCode message handlers

const char* code[] = {
	"\\c// --- sample.cpp",
	"\\n#include <iostream>",
	"\\kint\\n main()",
	"{",
	"\t\\c// Say hello",
	"\t\\nstd::cout << \\s\"Hello\"\\n;",
	"\t\\kreturn\\n 0;",
	"}"
};

void CSampleCode::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	const int ht = 13;
	const int wd = 7;

	CFont font;
	font.CreateFont(ht,wd,0,0,400,0,0,0,0,1,2,1,49,"Courier New");
	CFont* pOldFont = dc.SelectObject(&font);


	COLORREF backgroundcolor = m_syntaxcolor ? m_backgroundcolor : RGB(255,255,255);
	COLORREF normalcolor = m_syntaxcolor ? m_normalcolor : RGB(0,0,0);
	dc.SetBkColor(backgroundcolor);
	dc.SetTextColor(normalcolor);
	CRect rc;
	GetClientRect(&rc);
	CBrush br(backgroundcolor);
	dc.FillRect(&rc, &br);

	for (int i = 0; i < sizeof code / sizeof(const char*); i++)	{
		int x = 0;
		const char* cp = code[i];
		for (cp = code[i]; *cp; cp++)	{
			char ch[] = " ";
			if (*cp == '\\')	{
				cp++;
				if (m_syntaxcolor)	{
					COLORREF clr;
					switch (*cp)	{
						case 'n':
							clr = m_normalcolor;
							break;
						case 's':
							clr = m_stringcolor;
							break;
						case 'k':
							clr = m_keywordcolor;
							break;
						case 'c':
							clr = m_commentcolor;
							break;
						default:
							break;
					}
					dc.SetTextColor(clr);
				}
				continue;
			}
			else if (*cp == '\t')
				for (; x < m_tabstops; x++)
					dc.TextOut(x * wd, i * ht, ch);
			else	{
				*ch = *cp;
				int col = (x++) * wd;
				if (col + wd < rc.right)
					dc.TextOut(col, i * ht, ch);
			}
		}
	}

	dc.SelectObject(pOldFont);
}
