// --- setupDlg.cpp
#include "stdafx.h"

#include <WINNETWK.H>
#include <SHLOBJ.H>
#include <WINNLS.H>

#include <direct.h>
#include <io.h>
#include <sys\stat.h>
#include "setup.h"
#include "setupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CSetupDlg::CSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupDlg)
	m_strDoing = _T("");
	m_strPath = _T("");
	m_strSourceSpace = _T("");
	m_strTotalSpace = _T("");
	m_bInstallSource = FALSE;
	m_strAvailableSpace = _T("");
	m_strQuincySpace = _T("");
	m_bInstallMingw32 = FALSE;
	m_bInstallQuincy = FALSE;
	m_strMingw32Space = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bCopying = FALSE;
	m_bAborting = FALSE;
	m_nFileCount = 0;
	m_bReusingDirectory = FALSE;
	m_nTotalFiles = 0;
	m_nDiskSpaceRequired = 0;
}
void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupDlg)
	DDX_Control(pDX, ID_HTML, m_ctlHTML);
	DDX_Control(pDX, IDC_INSTALL, m_butInstall);
	DDX_Control(pDX, IDC_PROGRESS, m_ctlProgress);
	DDX_Text(pDX, IDC_DOING, m_strDoing);
	DDX_Text(pDX, IDC_PATH, m_strPath);
	DDX_Text(pDX, IDC_SOURCESPACE, m_strSourceSpace);
	DDX_Text(pDX, IDC_TOTALSPACE, m_strTotalSpace);
	DDX_Check(pDX, IDC_INSTALLEXERCISE, m_bInstallSource);
	DDX_Text(pDX, IDC_AVAILABLESPACE, m_strAvailableSpace);
	DDX_Text(pDX, IDC_QUINCYSPACE, m_strQuincySpace);
	DDX_Check(pDX, IDC_INSTALLMINGW32, m_bInstallMingw32);
	DDX_Check(pDX, IDC_INSTALLQUINCY, m_bInstallQuincy);
	DDX_Text(pDX, IDC_MINGW32SPACE, m_strMingw32Space);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INSTALL, OnInstall)
	ON_BN_CLICKED(IDC_INSTALLEXERCISE, OnInstallButton)
	ON_EN_CHANGE(IDC_PATH, OnChangePath)
	ON_BN_CLICKED(IDC_INSTALLEXES, OnInstallButton)
	ON_BN_CLICKED(IDC_INSTALLQUINCY, OnInstallButton)
	ON_BN_CLICKED(IDC_INSTALLMINGW32, OnInstallButton)
	ON_BN_CLICKED(ID_HTML, OnHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static struct space {
    int filect;
	long spacereqd;
} Space[] = {
    { 533,   347 },		// Exercise source code
    {  10,  1550 },		// Quincy and LCC
	{ 484, 22800 },		// Mingw32
};

void CSetupDlg::BuildTotals()
{
	m_nTotalFiles = 0;
	m_nDiskSpaceRequired = 0;

	m_strSourceSpace.Format ("%10ld", m_bInstallSource  ? Space[0].spacereqd : 0);
	m_strQuincySpace.Format ("%10ld", m_bInstallQuincy  ? Space[1].spacereqd : 0);
	m_strMingw32Space.Format("%10ld", m_bInstallMingw32 ? Space[2].spacereqd : 0);

	if (m_bInstallSource)	{
		m_nTotalFiles += Space[0].filect;
		m_nDiskSpaceRequired += Space[0].spacereqd;
	}
	if (m_bInstallQuincy)	{
		m_nTotalFiles += Space[1].filect;
		m_nDiskSpaceRequired += Space[1].spacereqd;
	}
	if (m_bInstallMingw32)	{
		m_nTotalFiles += Space[2].filect;
		m_nDiskSpaceRequired += Space[2].spacereqd;
	}

	m_strTotalSpace.Format ("%10ld", m_nDiskSpaceRequired);

	DWORD nSectorsPerCluster;
	DWORD nBytesPerSector;
	DWORD nNumberOfFreeClusters;
	DWORD nTotalNumberOfClusters;

	char drive = toupper(m_strPath.GetAt(0));
	char path[] = "c:\\";
	path[0] = drive;
	path[1] = m_strPath.GetAt(1);
	m_nSpace = 
		GetDiskFreeSpace(path, &nSectorsPerCluster, &nBytesPerSector, &nNumberOfFreeClusters, &nTotalNumberOfClusters) ?
		((nNumberOfFreeClusters * (nSectorsPerCluster * nBytesPerSector)) / 1024) : 0;

	m_strAvailableSpace.Format("%10ld", m_nSpace);

	UpdateData(FALSE);
}

BOOL CSetupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_strPath = "C:\\Quincy99";

	m_bInstallSource = TRUE;
	m_bInstallQuincy = TRUE;
	m_bInstallMingw32 = TRUE;

	if (theApp.GetBrowserPath().IsEmpty())
		m_ctlHTML.EnableWindow(FALSE);


	BuildTotals();

	return TRUE;
}
void CSetupDlg::OnPaint() 
{
	if (IsIconic())	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
		CDialog::OnPaint();
}
HCURSOR CSetupDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSetupDlg::OnInstall() 
{
	UpdateData(TRUE);

	// ----- edit path information
	char drive = toupper(m_strPath.GetAt(0));
	char path[] = "c:\\";
	path[0] = drive;

	if (drive < 'A' || drive > 'Z' || m_strPath[1] != ':' || m_strPath[2] != '\\')	{
		AfxMessageBox("Error! Specify target drive and directory (e.g. C:\\Quincy99)", MB_ICONSTOP);
		return;
	}

	if (m_bInstallMingw32 && m_strPath.Find(' ') != -1)	{
		AfxMessageBox("Error! You cannot install the compiler into a path that has space characters", MB_ICONSTOP);
		return;
	}

	BuildTotals();

	// ----- test for available disk space
	m_strDoing = "Checking for available disk space";
	UpdateData(FALSE);
	
	if (m_nSpace < m_nDiskSpaceRequired)	{
		CString msg;
		msg.Format( "Error! Quincy 99 requires %ldKB\n"
					"%c: has only %ldKB", m_nDiskSpaceRequired, *path, m_nSpace);
		AfxMessageBox(msg, MB_ICONSTOP);
		m_strDoing = "";
		UpdateData(FALSE);
		return;
	}

/*
	// ---- enough space, verify installation request
	CString strMsg("Install to ");
	strMsg += m_strPath + "?";
	if (AfxMessageBox(strMsg, MB_YESNO | MB_ICONQUESTION) != IDYES)	{
		m_strDoing = "";
		UpdateData(FALSE);
		return;
	}
*/
	// ---- if path ends with \ delete it
	if (m_strPath.Right(1) == "\\")	{
		if (m_strPath.Right(2) == ":\\")	{
			// ---- do not allow installation to the root directory
			AfxMessageBox("Cannot install into the root directory", MB_ICONSTOP);
			return;
		}
		else
			m_strPath = m_strPath.Left(m_strPath.GetLength()-1);
	}

	// ----- test to see if installation subdirectory exists
	if (_chdir(m_strPath) == 0)	{
		CString msg(m_strPath);
		msg += " already exists.\nUse it?";
		if (AfxMessageBox(msg, MB_YESNO | MB_ICONQUESTION) != IDYES)	{
			m_strDoing = "";
			UpdateData(FALSE);
			return;
		}
		m_bReusingDirectory = TRUE;
	}

	m_butInstall.EnableWindow(FALSE);

	m_ctlProgress.SetRange(0, m_nTotalFiles);
	m_ctlProgress.SetStep(1);

	m_bCopying = TRUE;
	m_strDoing = "Copying:";
	UpdateData(FALSE);
	AfxBeginThread(&CSetupDlg::StartCopies, this);
}

UINT CSetupDlg::StartCopies(void* This)
{
	((CSetupDlg*)This)->CopyFiles();
	return 0;
}

void MakeShortCut(LPCSTR lpszPathLink, LPCSTR lpszDesc, LPCSTR lpszPathObj)
{
	CoInitialize(0);
	HRESULT hres;
	IShellLink *psl;
	hres = CoCreateInstance(CLSID_ShellLink, 0, 
		CLSCTX_INPROC_SERVER, IID_IShellLink, (void**)&psl);
	if (SUCCEEDED(hres))	{
		IPersistFile* ppf;
		psl->SetPath(lpszPathObj);
		psl->SetDescription(lpszDesc);
		hres = psl->QueryInterface(IID_IPersistFile, (void**) &ppf);
		if (SUCCEEDED(hres))	{
			WORD wsz[MAX_PATH];
			int nMbwc = MultiByteToWideChar(CP_ACP, 0, 
				lpszPathLink, -1, wsz, MAX_PATH);
			hres = ppf->Save(wsz, TRUE);
			ppf->Release();
		}
		psl->Release();
	}
	CoUninitialize();
}

void AddToStartMenu(LPCSTR lpszProgram, LPCSTR lpszDesc, LPCSTR lpszPathObj)
{
	char szPathLink[MAX_PATH];

	LPITEMIDLIST item;
	SHGetSpecialFolderLocation(0, CSIDL_PROGRAMS, &item);
	SHGetPathFromIDList(item, szPathLink);

	strcat(szPathLink, "\\");
	// --- create the Start Menu\Programs subdirectory for the shortcut
	strcat(szPathLink, lpszProgram);
	_mkdir(szPathLink);
	// --- create the shortcut path
	strcat(szPathLink, "\\");
	strcat(szPathLink, lpszDesc);
	strcat(szPathLink, ".lnk");

	MakeShortCut(szPathLink, lpszDesc, lpszPathObj);
}

void AddToDesktop(LPCSTR lpszDesc, LPCSTR lpszPathObj)
{
	char szPathLink[MAX_PATH];

	LPITEMIDLIST item;
	SHGetSpecialFolderLocation(0, CSIDL_DESKTOPDIRECTORY, &item);
	SHGetPathFromIDList(item, szPathLink);

	// --- create the shortcut path
	strcat(szPathLink, "\\");
	strcat(szPathLink, lpszDesc);
	strcat(szPathLink, ".lnk");

	MakeShortCut(szPathLink, lpszDesc, lpszPathObj);
}

void CSetupDlg::AddMenuAndShortCut(const CString& strQuincyPath)
{
	char szPathObj[MAX_PATH];
	strcpy(szPathObj, strQuincyPath);
	strcat(szPathObj, "\\bin\\quincy.exe");
	AddToStartMenu("Quincy 99", "Quincy 99", szPathObj);

	if (AfxMessageBox("Add a Quincy 99 shortcut to the desktop?", MB_ICONQUESTION | MB_YESNO) == IDYES)
		AddToDesktop("Quincy 99", szPathObj);
}

void CSetupDlg::CopyFiles()
{
	CString strSourcePath(theApp.GetSourcePath() + "\\Quincy99");

	CopyFiles(m_strPath, strSourcePath);
	if (m_bCopying)	{
		CString& strQuincyPath = m_bInstallQuincy ? m_strPath : strSourcePath;
		AddMenuAndShortCut(strQuincyPath);
		char szUninstallPath[MAX_PATH];
		strcpy(szUninstallPath, strQuincyPath);
		strcat(szUninstallPath, "\\bin\\Uninstall.exe");
		AddToStartMenu("Quincy 99", "Uninstall", szUninstallPath);

		HKEY hKey1;
		if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software", 0, KEY_CREATE_SUB_KEY, &hKey1) == ERROR_SUCCESS)	{
			DWORD dwResult;
			HKEY hKey2;
			if (RegCreateKeyEx(hKey1, "Al Stevens Programs", 0, 0, REG_OPTION_NON_VOLATILE, KEY_CREATE_SUB_KEY, 0, &hKey2, &dwResult) == ERROR_SUCCESS)	{
				HKEY hKey3;
				if (RegCreateKeyEx(hKey2, "Quincy 99", 0, 0, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, 0, &hKey3, &dwResult) == ERROR_SUCCESS)	{
					HKEY hKey4;
					if (RegCreateKeyEx(hKey3, "Directories", 0, 0, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, 0, &hKey4, &dwResult) == ERROR_SUCCESS)	{
						char szPathObj[MAX_PATH];
						strcpy(szPathObj, m_strPath);
						strcat(szPathObj, "\\");
						RegSetValueEx(hKey4, "Installed", 0, REG_SZ, (const unsigned char*) szPathObj, strlen(szPathObj)+1);
						strcat(szPathObj, "Working\\");
						RegSetValueEx(hKey4, "WorkingPath", 0, REG_SZ, (const unsigned char*) szPathObj, strlen(szPathObj)+1);
						strcpy(szPathObj, m_bInstallSource ? m_strPath : strSourcePath);
						strcat(szPathObj, "\\Programs\\");
						RegSetValueEx(hKey4, "Tutorial", 0, REG_SZ, (const unsigned char*) szPathObj, strlen(szPathObj)+1);
						strcpy(szPathObj, m_bInstallMingw32 ? m_strPath : strSourcePath);
						strcat(szPathObj, "\\Mingw32\\");
						RegSetValueEx(hKey4, "Compiler", 0, REG_SZ, (const unsigned char*) szPathObj, strlen(szPathObj)+1);
						RegCloseKey(hKey4);
					}
					RegCloseKey(hKey3);
				}
				RegCloseKey(hKey2);
			}
			RegCloseKey(hKey1);
		}

		if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE", 0, KEY_READ, &hKey1) == ERROR_SUCCESS)	{
			HKEY hKey2;
			if (RegOpenKeyEx(hKey1, "Microsoft", 0, KEY_READ, &hKey2) == ERROR_SUCCESS)	{
				HKEY hKey3;
				if (RegOpenKeyEx(hKey2, "Windows", 0, KEY_READ, &hKey3) == ERROR_SUCCESS)	{
					HKEY hKey4;
					if (RegOpenKeyEx(hKey3, "CurrentVersion", 0, KEY_READ, &hKey4) == ERROR_SUCCESS)	{
						HKEY hKey5;
						if (RegOpenKeyEx(hKey4, "Uninstall", 0, KEY_CREATE_SUB_KEY, &hKey5) == ERROR_SUCCESS)	{
							DWORD dwResult;
							HKEY hKey6;
							if (RegCreateKeyEx(hKey5, "Quincy 99", 0, 0, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, 0, &hKey6, &dwResult) == ERROR_SUCCESS)	{
								RegSetValueEx(hKey6, "DisplayName", 0, REG_SZ, (const unsigned char*) "Quincy 99", 10);
								RegSetValueEx(hKey6, "UninstallString", 0, REG_SZ, (const unsigned char*) szUninstallPath, strlen(szUninstallPath)+1);
								RegCloseKey(hKey6);
							}
							RegCloseKey(hKey5);
						}
						RegCloseKey(hKey4);
					}
					RegCloseKey(hKey3);
				}
				RegCloseKey(hKey2);
			}
			RegCloseKey(hKey1);
		}
		if (!theApp.GetBrowserPath().IsEmpty())	{
			char msg[300];
			sprintf(msg,	"Setup completed, %d files copied.\n\n"
							"  View Quincy 99 User's Guide?\n\n"
							"(You can view it later by double-clicking\n"
							"the Quincy99.htm icon in the CD-ROM's\nroot directory.",
							m_nFileCount);
			if (AfxMessageBox(msg, MB_ICONQUESTION | MB_YESNO) == IDYES)
				OnHelp();
		}
	}
	else 
		AfxMessageBox("Setup did not run to completion.", MB_ICONSTOP);
	PostMessage(WM_COMMAND, IDOK, 0);
	m_bCopying = FALSE;
}

// ----  extract the filename from a path specification
CString CSetupDlg::GetFileName(const CString& rstrPath) const
{
	int offset = rstrPath.ReverseFind('\\');
	if (offset == -1)
		offset = rstrPath.ReverseFind('/');
	return offset == -1 ? rstrPath : rstrPath.Right(rstrPath.GetLength() - offset - 1);
}

void CSetupDlg::CopyFiles(const CString& strDestination, const CString& strSource)
{
	CString strDirName = GetFileName(strSource);
	if (!m_bInstallSource && strDirName.CompareNoCase("programs") == 0)
		return;

	// ------ make the destination subdirectory
	if (_mkdir(strDestination) != 0 && m_bReusingDirectory == FALSE)	{
		CString msg("Error! Cannot create ");
		msg += strDestination;
		AfxMessageBox(msg, MB_ICONSTOP);
		m_bCopying = FALSE;
		m_bAborting = TRUE;
		return;
	}

	// ------ scan for files to copy
	struct _finddata_t fileinfo;

	CString strSub = strSource + "\\*.*";
	long hFile = _findfirst(strSub.GetBuffer(0), &fileinfo);
	while (!m_bAborting && hFile != -1)	{
		if (!m_bCopying)	{
			// ---- pressed Cancel
			if (AfxMessageBox("Stop copying?", MB_YESNO | MB_ICONQUESTION) == IDYES)	{
				m_bAborting = TRUE;
				break;
			}
			// --- changed your mind
			m_bCopying = TRUE;
		}

		// ---- build destination file specification
		CString strDest(strDestination);
		strDest += "\\";
		strDest += fileinfo.name;

		// ---- build source file specification
		CString strSrc(strSource);
		strSrc += "\\";
		strSrc += fileinfo.name;

		bool docopy = true;
		if (fileinfo.attrib & _A_SUBDIR)	{
			// --- this is a subdirectory
			if (*fileinfo.name != '.')	{
				if (!m_bInstallQuincy)	{
					if (strSrc.Right(12).CompareNoCase("quincy99\\bin") == 0)
						docopy = false;
					else if (strSrc.Right(12).CompareNoCase("quincy99\\lcc") == 0)
						docopy = false;
				}
				if (!m_bInstallMingw32)
					if (strSrc.Right(16).CompareNoCase("quincy99\\mingw32") == 0)
						docopy = false;
				if (docopy)
					CopyFiles(strDest, strSrc);
			}
		}
		else		{

			CString strFileName(fileinfo.name);

			if (docopy)	{
				SendMessage(WM_COMMAND, IDC_SETFILENAME, (LPARAM)strDest.GetBuffer(0));

				if (CopyFile(strSrc, strDest, FALSE) == FALSE)	{
					CString msg("Error! Unable to copy ");
					msg += strDest;
					AfxMessageBox(msg, MB_ICONSTOP);
					m_bCopying = FALSE;
					m_bAborting = TRUE;
					break;
				}

				m_nFileCount++;
				m_ctlProgress.StepIt();
				// ----- turn off read-only attribute in destination file
				_chmod(strDest, _S_IWRITE);
			}
		}
		if (_findnext(hFile, &fileinfo) == -1)
			hFile = -1;
	}
}
void CSetupDlg::OnCancel() 
{
	if (m_bCopying)
		m_bCopying = FALSE;
	else
		CDialog::OnCancel();
}
LRESULT CSetupDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if (message == WM_COMMAND && wParam == IDC_SETFILENAME)	{
		m_strDoing = (char*)lParam;
		UpdateData(FALSE);
		return TRUE;
	}
	return CDialog::WindowProc(message, wParam, lParam);
}

void CSetupDlg::OnInstallButton() 
{
	UpdateData(TRUE);
	BuildTotals();
}

void CSetupDlg::OnChangePath() 
{
	UpdateData(TRUE);
	BuildTotals();
}

void CSetupDlg::OnHelp() 
{
	CString strSourcePath(theApp.GetSourcePath());
	CString expl(theApp.GetBrowserPath() + " " + CString(strSourcePath[0]) + ":\\quincy99.htm");
	WinExec(expl, SW_SHOW);
}
