// setupDlg.h


class CSetupDlg : public CDialog
{
	static UINT StartCopies(void*);
	void CopyFiles();
	void CopyFiles(const CString& strDestination, const CString& strSource);
	bool m_bCopying;
	bool m_bAborting;
	bool m_bReusingDirectory;
	int  m_nFileCount;
	LONG m_nDiskSpaceRequired;	// space required in KB 
	int  m_nTotalFiles;			// number of files to copy
	LONG m_nSpace;				// space available
	void BuildTotals();
	CString GetFileName(const CString& rstrPath) const;
	void AddMenuAndShortCut(const CString& strQuincyPath);
public:
	CSetupDlg(CWnd* pParent = NULL);
	//{{AFX_DATA(CSetupDlg)
	enum { IDD = IDD_SETUP_DIALOG };
	CButton	m_ctlHTML;
	CButton	m_butInstall;
	CProgressCtrl m_ctlProgress;
	CString	m_strDoing;
	CString	m_strPath;
	CString	m_strSourceSpace;
	CString	m_strTotalSpace;
	BOOL	m_bInstallSource;
	CString	m_strAvailableSpace;
	CString	m_strQuincySpace;
	BOOL	m_bInstallMingw32;
	BOOL	m_bInstallQuincy;
	CString	m_strMingw32Space;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CSetupDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

protected:
	HICON m_hIcon;
	//{{AFX_MSG(CSetupDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnInstall();
	virtual void OnCancel();
	afx_msg void OnInstallButton();
	afx_msg void OnChangePath();
	afx_msg void OnHelp();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
