// WatchDialog.cpp : implementation file
//

#include "stdafx.h"
#include "quincy.h"
#include "WatchDialog.h"
#include "AddWatch.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWatchDialog dialog


CWatchDialog::CWatchDialog(CWnd* pParent)
	: CDialog(CWatchDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWatchDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CWatchDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWatchDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWatchDialog, CDialog)
	//{{AFX_MSG_MAP(CWatchDialog)
	ON_BN_CLICKED(IDC_ADDWATCH, OnAddwatch)
	ON_BN_CLICKED(IDC_DELETEWATCH, OnDeletewatch)
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_DELETEWATCHES, OnDeletewatches)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWatchDialog message handlers

int CWatchDialog::GetWatchCount()
{
	CListBox* pList = static_cast<CListBox*>(GetDlgItem(IDC_WATCHLIST));
	ASSERT(pList != 0);
	return pList->GetCount();
}

void CWatchDialog::GetWatchValue(int nSel, CString& strValue)
{
	CListBox* pList = static_cast<CListBox*>(GetDlgItem(IDC_WATCHLIST));
	ASSERT(pList != 0);
	pList->GetText(nSel, strValue);
	int nIndex = strValue.Find(':');
	if (nIndex != -1)
		strValue = strValue.Left(nIndex);
}

void CWatchDialog::OnAddwatch() 
{
	CAddWatch dlgAddWatch;
	if (dlgAddWatch.DoModal() == IDOK)
		AddWatch(dlgAddWatch.m_strWatchVariable);
}

void CWatchDialog::AddWatch(const CString& strWatch)
{
	if (!strWatch.IsEmpty())	{
		CListBox* pList = static_cast<CListBox*>(GetDlgItem(IDC_WATCHLIST));
		ASSERT(pList != 0);
		RefreshWatch(pList->AddString(strWatch));
	}
}

void CWatchDialog::OnDeletewatch() 
{
	CListBox* pList = static_cast<CListBox*>(GetDlgItem(IDC_WATCHLIST));
	ASSERT(pList != 0);
	int nSel = pList->GetCurSel();
	if (nSel != LB_ERR)	{
		pList->DeleteString(nSel);
		int nCt = pList->GetCount();
		if (nSel < nCt)
			pList->SetCurSel(nSel);
		else if (nSel > 0)
			pList->SetCurSel(nSel-1);
	}
}

void CWatchDialog::OnDeletewatches() 
{
	ClearWatches();
}

void CWatchDialog::RefreshWatch(int nSel)
{
	CListBox* pList = static_cast<CListBox*>(GetDlgItem(IDC_WATCHLIST));
	ASSERT(pList != 0);
	CString strVarName;
	pList->GetText(nSel, strVarName);
	int offset = strVarName.Find(':');
	if (offset != -1)
		strVarName = strVarName.Left(offset);
	CString strVarValue;
	theApp.GetVariableValue(strVarName, strVarValue);
	CString strWatch = strVarName + ": " + strVarValue;
	pList->DeleteString(nSel);
	pList->InsertString(nSel, strWatch);
}

void CWatchDialog::RefreshAllWatches()
{
	CListBox* pList = static_cast<CListBox*>(GetDlgItem(IDC_WATCHLIST));
	ASSERT(pList != 0);
	int nCt = pList->GetCount();
	for (int nSel = 0; nSel < nCt; nSel++)
		RefreshWatch(nSel);
}

void CWatchDialog::OnDestroy()
{
	theApp.SaveDialogWindowPosition("WatchWindow", this);
	CDialog::OnDestroy();
}

int CWatchDialog::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	theApp.RestoreDialogWindowPosition("WatchWindow", this);
	return 0;
}

void CWatchDialog::ClearWatches()
{
	CListBox* pList = static_cast<CListBox*>(GetDlgItem(IDC_WATCHLIST));
	ASSERT(pList != 0);
	pList->ResetContent();
}

