// TextView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTextView view

#include "EditorView.h"

class CTextView : public CEditorView
{
	CFont newfont;

	BOOL DoCompile(BOOL bDoLink, BOOL bDoExecute, BOOL bDoStep = FALSE, BOOL bUseTD = FALSE);
	void WriteMarginBitmap(int nRow, CBitmap& bm);
	CString SourceCodeFileName();
	int RelativeRow(int nLineno);
	BOOL CanBuild();
	BOOL IsSourceFile();
	friend class CQuincyApp;
protected:
	CTextView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CTextView)

// Attributes
public:

// Operations
public:
	void SetBreakpointDisplay(int nLineNo, BOOL bOnOff);
	void SetPCBreakpointDisplay(int nLineNo);
	void SetProgramCounterDisplay(int nLineNo, BOOL bOnOff);
	void BuildAndRunProgram(BOOL bStep, BOOL useTD = FALSE);
	void DrawMargins();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTextView)
	public:
	protected:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CTextView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	// Generated message map functions
protected:
	//{{AFX_MSG(CTextView)
	afx_msg void OnBuild();
	afx_msg void OnBuildall();
	afx_msg void OnCompile();
	afx_msg void OnExecute();
	afx_msg void OnDebugBreakpoint();
	afx_msg void OnDebugStep();
	afx_msg void OnDebugSteptocursor();
	afx_msg void OnUpdateBuild(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBuildAll(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCompile(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAll(CCmdUI* pCmdUI);
	afx_msg void OnDebugStepoutoffunction();
	afx_msg void OnTurbodebugger();
	afx_msg void OnUpdateTurbodebugger(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
