// ---- breakpoint.cpp

#include "stdafx.h"
#include "breakpoint.h"

Breakpoint& Breakpoint::operator=(const Breakpoint& bp)
{
	if (this != &bp)	{
		m_FileRef = bp.m_FileRef;
		m_cSaveInst = bp.m_cSaveInst;
	}
	return *this;
}
void RuntimeBreakpoints::SetBreakpoint(MemoryAddress addr, Breakpoint& bp, HANDLE hProcess, bool bSet)
{
	if (bSet)	{
		ReadProcessMemory(hProcess, (void*)addr, &bp.m_cSaveInst, 1, 0);
		WriteProcessMemory(hProcess, (void*)addr, "\xcc", 1, 0);
	}
	else	{
		unsigned char ch;
		ReadProcessMemory(hProcess, (void*)addr, &ch, 1, 0);
		if (ch == 0xcc)
			WriteProcessMemory(hProcess, (void*)addr, &bp.m_cSaveInst, 1, 0);
	}
}
void RuntimeBreakpoints::SetBreakpoint(MemoryAddress addr, HANDLE hProcess, bool bSet)
{
	bp_iterator iter = cntr.find(addr);
	if (iter != cntr.end())
		SetBreakpoint(addr, (*iter).second, hProcess, bSet);
}
void RuntimeBreakpoints::SetAllBreakpoints(HANDLE hProcess, bool bSet)
{
	bp_iterator iter;
	for (iter = cntr.begin(); iter != cntr.end(); iter++)
		SetBreakpoint((*iter).first, (*iter).second, hProcess, bSet);
}
Breakpoint* RuntimeBreakpoints::FindBreakpoint(MemoryAddress addr)
{
	RuntimeBreakpoints::bp_iterator iter = cntr.find(addr);
	if (iter == cntr.end())
		return 0;
	return &(*iter).second;
}
void RuntimeBreakpoints::LoadBreakpoint(const FileReference& fref, MemoryAddress addr)
{
	cntr.insert(std::pair<MemoryAddress, Breakpoint>(addr, Breakpoint(fref)));
}

void RuntimeBreakpoints::ClearAllBreakpoints(HANDLE hProcess)
{
	SetAllBreakpoints(hProcess, false);
	cntr.clear();
}

#ifdef _DEBUG
void RuntimeBreakpoints::DumpBreakpoints()
{
	TRACE("\n----------- breakpoints ----------------");
	bp_iterator iter;
	for (iter = cntr.begin(); iter != cntr.end(); iter++)	{
		MemoryAddress addr = (*iter).first;
		Breakpoint bp = (*iter).second;
		TRACE("\nDumping %p %s %d", addr, bp.m_FileRef.m_strFile, bp.m_FileRef.m_nLineNo);
	}
	TRACE("\n----------------------------------------\n");
}
#endif
