// OptionsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "Quincy.h"
#include "OptionsDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsDialog dialog


COptionsDialog::COptionsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionsDialog)
	m_strCommandLine = _T("");
	m_strRuntimeDirectory = _T("");
	m_CommandLinePromptOption = -1;
	m_bDebugging = FALSE;
	m_bExceptions = FALSE;
	m_bRTTI = FALSE;
	m_strDefine = _T("");
	m_strInclude = _T("");
	m_strLib = _T("");
	m_bStrict = FALSE;
	//}}AFX_DATA_INIT
	m_nOptimize = 0;
}


void COptionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDialog)
	DDX_Control(pDX, IDC_OPTIMIZE, m_Optimize);
	DDX_Control(pDX, IDC_OPTIMIZESPIN, m_OptimizeSpin);
	DDX_Text(pDX, IDC_COMMAND_LINE, m_strCommandLine);
	DDX_Text(pDX, IDC_RUNTIMEDIRECTORY, m_strRuntimeDirectory);
	DDX_Radio(pDX, IDC_PROMPT_CMDLINE, m_CommandLinePromptOption);
	DDX_Check(pDX, IDC_DEBUG, m_bDebugging);
	DDX_Check(pDX, IDC_EXCEPTIONS, m_bExceptions);
	DDX_Check(pDX, IDC_RTTI, m_bRTTI);
	DDX_Text(pDX, IDC_DEFINE, m_strDefine);
	DDX_Text(pDX, IDC_INCLUDE, m_strInclude);
	DDX_Text(pDX, IDC_LIB, m_strLib);
	DDX_Check(pDX, IDC_STRICT, m_bStrict);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionsDialog, CDialog)
	//{{AFX_MSG_MAP(COptionsDialog)
	ON_BN_CLICKED(IDC_DEBUG, OnDebug)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDialog message handlers


BOOL COptionsDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_OptimizeSpin.SetRange(0,3);
	OnDebug();
	return TRUE;
}

void COptionsDialog::OnDebug() 
{
	UpdateData(TRUE);
	if (m_bDebugging)	{
		m_OptimizeSpin.SetPos(0);
		m_Optimize.EnableWindow(FALSE);
		m_OptimizeSpin.EnableWindow(FALSE);
	}
	else	{
		m_Optimize.EnableWindow();
		m_OptimizeSpin.EnableWindow();
		m_OptimizeSpin.SetPos(m_nOptimize);
	}
}

void COptionsDialog::OnOK() 
{
	m_nOptimize = m_OptimizeSpin.GetPos();
	CDialog::OnOK();
}
