// TextView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTextView view

class CTextView : public CEditView
{
	CFont newfont;
	int m_nFontHeight;
	int m_nFontWidth;

	BOOL DoCompile(BOOL bDoLink, BOOL bDoExecute, BOOL bDoStep = FALSE);
	void WriteMarginCharacter(int nLine, int ch, COLORREF clr);
	void ShowLineColumn();
	int CurrentLineNumber();
	int CurrentColumn();
	CString SourceCodeFileName();
	int RelativeLine(int nLineno);
	LPSTR GetTextLine(int nLineno, int& nWidth);
	BOOL CanBuild();
	BOOL IsSourceFile();
	friend class CQuincyApp;
protected:
	CTextView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CTextView)

// Attributes
public:

// Operations
public:
	void SetBreakpointDisplay(int nLineNo, BOOL bOnOff);
	void SetProgramCounterDisplay(int nLineNo, BOOL bOnOff);
	void BuildAndRunProgram(BOOL bStep);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTextView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CTextView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CTextView)
	afx_msg void OnBuild();
	afx_msg void OnBuildall();
	afx_msg void OnCompile();
	afx_msg void OnExecute();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnDebugBreakpoint();
	afx_msg void OnDebugStep();
	afx_msg void OnDebugSteptocursor();
	afx_msg void OnUpdateBuild(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBuildAll(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCompile(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAll(CCmdUI* pCmdUI);
	afx_msg void OnDebugStepoutoffunction();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
