// ---- bass.h

#ifndef BASS_H
#define BASS_H

#include "midoutdv.h"

class Bass : public midiOutDevice	{
	int lastnote;
	CChord lastchord;
	BOOL m_bNewChord;
	int m_nPlayingLine;
	int m_nLine;
	int m_nLineVariation;
	BOOL m_bSwingingTune;
	int m_nGraceCounter;

	void PlayBassNote(int measure, int beat, int third = 0);
	void LastNoteOff();
	void PlayNote(int relative, int velocity = 100);
	void PlayNoteAbsolute(int note, int velocity = 100);
	void SelectLine(int nLine);
	int RandomGraceCounter();
public:
	Bass(MidiOut* pMidiOut);
	void StartPlaying();
	void StopPlaying()
		{ LastNoteOff(); }
	void TimingMessage(int measure, int beat, int clock);
};

#endif
