// ---- CMFEvents.h

#ifndef CMFEVENTS_H
#define CMFEVENTS_H

const int nInitialCMFEvents = 4096;
const int nAppendCMFEvents = 1024;

class CMFEvents	{
	int m_nEventsAllocated;
	int m_nEventCount;
	DWORD m_dwPrevClock;
	struct CMFEvent	{
		DWORD dwClock;
		DWORD dwMidiEvent;
		CMFEvent()
			{ dwClock = dwMidiEvent = 0; }
	} *m_pCMFEvents;
public:
	CMFEvents();
	~CMFEvents();
	void Initialize();
	void PostEvent(DWORD cdClock, DWORD dwEvent);
	int EventCount() const
		{ return m_nEventCount; }
	DWORD MidiEvent(int nEventNo) const
		{ ASSERT (nEventNo < m_nEventCount); return m_pCMFEvents[nEventNo].dwMidiEvent; }
	DWORD Clock(int nEventNo) const
		{ ASSERT (nEventNo < m_nEventCount); return m_pCMFEvents[nEventNo].dwClock; }
};

#endif
