// DlgSelectChord.cpp : implementation file
//

#include "stdafx.h"
#include "midifitz.h"
#include "DlgSelectChord.h"
#include "song.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgSelectChord dialog

midiChord CDlgSelectChord::m_Selections[] = {
//   root major  minor   7th    dim    aug   MAJ7   flatted 5th
      {0, TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE, FALSE},	// maj
      {0, TRUE,  FALSE, TRUE,  FALSE, FALSE, FALSE, FALSE},	// 7
      {0, TRUE,  FALSE, TRUE,  FALSE, FALSE, FALSE, TRUE },	// 7b5
      {0, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE,  FALSE},	// Maj7
      {0, FALSE, TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE},	// mi
      {0, FALSE, TRUE,  TRUE,  FALSE, FALSE, FALSE, FALSE},	// mi7
      {0, FALSE, TRUE,  TRUE,  FALSE, FALSE, FALSE, TRUE },	// mi7b5
      {0, FALSE, FALSE, FALSE, TRUE,  FALSE, FALSE, FALSE},	// dim
      {0, FALSE, FALSE, FALSE, FALSE, TRUE,  FALSE, FALSE},	// aug
};
int CDlgSelectChord::m_nChordEntries = sizeof(CDlgSelectChord::m_Selections) / sizeof(midiChord);

CDlgSelectChord::CDlgSelectChord(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSelectChord::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSelectChord)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_nSelection = -1;
	m_cKey = 0;
}


void CDlgSelectChord::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSelectChord)
	DDX_Control(pDX, IDC_BASSNOTELIST, m_BassNoteList);
	DDX_Control(pDX, IDC_CHORDLIST, m_ChordList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSelectChord, CDialog)
	//{{AFX_MSG_MAP(CDlgSelectChord)
	ON_LBN_DBLCLK(IDC_CHORDLIST, OnDblclkChordlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CChord CDlgSelectChord::GetChord(const CChord& oldChord)
{
	m_OldChord = oldChord;
	m_cKey = 0;
	CChord chord;
	if (DoModal() == IDOK)	{
		if (m_nSelection != -1)	{
			chord = m_Selections[m_nSelection % m_nChordEntries];
			chord.root = (m_nSelection / m_nChordEntries + 1) | (m_nBassSelection << 4);
		}
	}
	return chord;
}
CChord CDlgSelectChord::GetChord(char key)
{
	CChord chord;
	m_OldChord = chord;
	m_cKey = key;
	if (DoModal() == IDOK)	{
		if (m_nSelection != -1)	{
			chord = m_Selections[m_nSelection % m_nChordEntries];
			chord.root = (m_nSelection / m_nChordEntries + 1) | (m_nBassSelection << 4);
		}
	}
	return chord;
}

/////////////////////////////////////////////////////////////////////////////
// CDlgSelectChord message handlers

BOOL CDlgSelectChord::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString strChord;
	static char* BassNotes[] = {
		"A","Bb","B","C","Dd","D","Eb","E","F","F#","G","Ab"
	};
	m_BassNoteList.AddString("(none)");
	for(int i = 0; i < 12; i++)	{
		m_BassNoteList.AddString(BassNotes[i]);
		for (int j = 0; j < m_nChordEntries; j++)	{
			m_Selections[j].root = i+1;
			theSong.BuildChordDisplay(strChord, m_Selections[j]);
			m_ChordList.AddString(strChord);
			if (m_OldChord.root)	{
				CChord chord = m_Selections[j];
				if ((chord.root&0xf) == (m_OldChord.root&0xf) && chord.attr == m_OldChord.attr)
					m_ChordList.SetCurSel(i * m_nChordEntries + j);
			}
		}
	}
	if (m_cKey)
		m_ChordList.PostMessage(WM_CHAR, m_cKey);
	m_BassNoteList.SetCurSel((m_OldChord.root >> 4) & 0xf);
	return TRUE;
}

void CDlgSelectChord::OnOK() 
{
	CString strChord;
	m_ChordList.GetWindowText(strChord);
	struct RootAlias {
		char* newroot;
		char* oldroot;
	} aliases[] = {
		{"Bb", "A#"},
		{"B",  "Cb"},
		{"C",  "B#"},
		{"Db", "C#"},
		{"Eb", "D#"},
		{"E",  "Fb"},
		{"F",  "E#"},
		{"F#", "Gb"},
		{"Ab", "G#"},
		{0, 0},
	};

	RootAlias* pra;
	for (pra = aliases; pra->oldroot != 0; pra++)	{
		int nLen = strlen(pra->oldroot);
		if (strChord.Left(nLen).CompareNoCase(pra->oldroot) == 0)	{
			strChord = CString(pra->newroot) + strChord.Right(strChord.GetLength() - nLen);
			break;
		}
	}
	int nIndex;

	if ((nIndex = strChord.Find('/')) != -1)	{
		CString strBass = strChord.Right(strChord.GetLength() - nIndex - 1);
		for (pra = aliases; pra->oldroot != 0; pra++)	{
			int nLen = strlen(pra->oldroot);
			if (strBass.CompareNoCase(pra->oldroot) == 0)	{
				strBass = CString(pra->newroot);
				break;
			}
		}
//		if (m_BassNoteList.SelectString(-1, strBass) == CB_ERR)
//			return;

		m_nBassSelection = -1;
		while (m_BassNoteList.SelectString(m_nBassSelection, strBass) != LB_ERR)	{
			int nBassSelection = m_BassNoteList.GetCurSel();
			CString strBassSelection;
			m_BassNoteList.GetText(nBassSelection, strBassSelection);
			if (strBassSelection.GetLength() == strBass.GetLength())	{
				m_nBassSelection = m_BassNoteList.GetCurSel();
				break;
			}
			m_nBassSelection = nBassSelection;
		}

		if (m_nBassSelection == -1)
			return;

		strChord = strChord.Left(nIndex);
	}

	// ---- convert min to mi
	if ((nIndex = strChord.Find("min")) != -1)
		strChord = strChord.Left(nIndex+2)+strChord.Right(strChord.GetLength()-nIndex-3);

	// ---- convert + to aug
	else if ((nIndex = strChord.Find('+')) != -1)
		strChord = strChord.Left(nIndex)+"aug"+strChord.Right(strChord.GetLength()-nIndex-1);

	// ---- convert - to mi
	else if ((nIndex = strChord.Find('-')) != -1)
		strChord = strChord.Left(nIndex)+"mi"+strChord.Right(strChord.GetLength()-nIndex-1);

	// ---- convert o to dim
	else if ((nIndex = strChord.Find('o')) != -1)
		strChord = strChord.Left(nIndex+1)+"im"+strChord.Right(strChord.GetLength()-nIndex-1);

	// ---- convert M7 to Maj7
	else if ((nIndex = strChord.Find("M7")) > 0)
		strChord = strChord.Left(nIndex+1)+"aj"+strChord.Right(strChord.GetLength()-nIndex-1);

	// ---- convert M to Maj7
	else if ((nIndex = strChord.Find('M')) > 0)	{
		if (strChord.GetLength() > 2 && nIndex == 1 && strChord[nIndex+1] != 'i' && strChord[nIndex+1] != 'a')
			strChord = strChord.Left(nIndex+1)+"aj"+strChord.Right(strChord.GetLength()-nIndex-1);
	}
	// ---- convert m to mi
	else if ((nIndex = strChord.Find("dim")) == -1)
		if ((nIndex = strChord.Find("mi")) == -1)
			if ((nIndex = strChord.Find("ma")) == -1)
				if ((nIndex = strChord.Find("m")) > 0)
					strChord = strChord.Left(nIndex+1)+'i'+strChord.Right(strChord.GetLength()-nIndex-1);


	while (m_ChordList.SelectString(m_nSelection, strChord) != CB_ERR)	{
		int nSelection = m_ChordList.GetCurSel();
		if (m_ChordList.GetLBTextLen(nSelection) == strChord.GetLength())	{
			m_nBassSelection = m_BassNoteList.GetCurSel();
			m_nSelection = nSelection;
			CDialog::OnOK();
		}
		if (nSelection <= m_nSelection)
			break;
		m_nSelection = nSelection;
	}
}

void CDlgSelectChord::OnDblclkChordlist() 
{
	OnOK();
}

