// ------ drums.h
#ifndef DRUMS_H
#define DRUMS_H

#include "midoutdv.h"
#include "song.h"

// Drum machine

class MidiOut;

struct Note {
	int note;		// note number
	int velocity;	// velocity
};

class Drums : public midiOutDevice	{
	int m_nSegment;
	int m_nLastNote;
	static Note styles[][2][4][8][4];
	static Note endings[][4][8][4];
	Note lasthit[4];
	Song::Style m_nDrumStyle;
	int m_nStyleIndex;
	void SetDrumStyle();
public:
	Drums(MidiOut* pMidiOut);
	void StartPlaying();
	void StopPlaying();
	void TimingMessage(int measure, int beat, int clock);
	void NoteOn(int note, int velocity)
		{ m_nLastNote = note; midiOutDevice::NoteOn(note, velocity); }
};

#endif
