// --- guitar.h

#ifndef GUITAR_H
#define GUITAR_H

#include "midoutdv.h"

class Guitar : public midiOutDevice	{
	int m_nRoot;
	int m_nThird;
	int m_nFifth;
	int m_nSeventh;
	void PlayChord(int beat);
	void NotesOff();
	void Adjust(int higher, int lower);
public:
	Guitar(MidiOut* pMidiOut) : midiOutDevice("Guitar", 3, 24, pMidiOut)
		{ }
	void Initialize();
	void StartPlaying()
		{ Initialize(); }
	void StopPlaying()
		{ NotesOff(); }
	void TimingMessage(int measure, int beat, int clock);
};

inline void Guitar::Adjust(int higher, int lower)
{
	while (lower < 32)
		lower+=12, higher+=12;
}


#endif
