// LeadSheet.cpp : implementation file
//

#include "stdafx.h"
#include "midifitz.h"
#include "LeadSheet.h"
#include "song.h"
#include "DlgSongTitle.h"
#include "TempoDlg.h"
#include "SongPage.h"
#include "StyleDlg.h"
#include "EndingDlg.h"
#include "DlgInsertMeasures.h"
#include "Options.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CPoint CLeadSheet::m_Beats[maxchords];
CRect CLeadSheet::m_Chords[maxchords];
CRect CLeadSheet::m_Measures[maxchords/3+1];
BOOL CLeadSheet::m_bRests[maxchords];

#define COPY_WHEN_CTRL_DOWN

#ifdef COPY_WHEN_CTRL_DOWN
#define hCtrlDownCursor m_hCopyCursor
#define hCtrlUpCursor   m_hMoveCursor
#define bCopying        m_bCtrlDown
#else
#define hCtrlDownCursor m_hMoveCursor
#define hCtrlUpCursor   m_hCopyCursor
#define bCopying        !m_bCtrlDown
#endif
#define bMoving         !bCopying

/////////////////////////////////////////////////////////////////////////////
// CLeadSheet

CLeadSheet::CLeadSheet()
{
	m_pCDC = 0;
	m_pCBitmap = 0;
	m_pOldCBitmap = 0;
	m_bClicked = FALSE;
	m_nWindowRows = 0;
	m_nCountOff = 0;
	NewSong();
	m_pClipboardEvents = 0;
	m_nClipboardCount = 0;
	m_bHasFocus = FALSE;
	m_pPage = 0;
	m_hOldCursor = 0;
	m_hArrowCursor = theApp.LoadStandardCursor(IDC_ARROW);
	m_hMoveCursor = theApp.LoadCursor(IDC_POINTER_MOVE);
	m_hCopyCursor = theApp.LoadCursor(IDC_POINTER_COPY);
}

CLeadSheet::~CLeadSheet()
{
	if (m_pCDC && m_pOldCBitmap)
		m_pCDC->SelectObject(m_pOldCBitmap);	// is this neccessary?
	delete m_pCBitmap;
	delete m_pCDC;
	delete [] m_pClipboardEvents;
}

BEGIN_MESSAGE_MAP(CLeadSheet, CLeadBase)
#ifndef DEMO_VERSION
	ON_COMMAND(IDC_SAVE, OnSaveCmd)
	ON_COMMAND(IDC_SAVEAS, OnSaveasCmd)
#endif
	//{{AFX_MSG_MAP(CLeadSheet)
	ON_WM_PAINT()
	ON_WM_VSCROLL()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_CHAR()
	ON_WM_SETCURSOR()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(IDC_BUILDMIDIFILE, OnBuildmidifileCmd)
	ON_COMMAND(IDC_COPY, OnCopyCmd)
	ON_COMMAND(IDC_CUT, OnCutCmd)
	ON_COMMAND(IDC_NEW, OnNewCmd)
	ON_COMMAND(IDC_OPEN, OnOpenCmd)
	ON_COMMAND(IDC_PASTE, OnPasteCmd)
	ON_COMMAND(IDC_PRINT, OnPrintCmd)
	ON_COMMAND(IDC_UNDO, OnUndoCmd)
	ON_COMMAND(IDC_ABBREVIATED, OnAbbreviated)
	ON_COMMAND(IDC_BASSCLEF, OnClef)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


const int maxstaffs = 128;
const int staffspace = 5;						// space between staff lines
const int staffpadding = 20;					// space between staffs
const int staffheight = staffspace * 4 + 1;		// height of a staff
const int topmargin = 20;						// top margin
const int margin = 10;							// side margins
const int scrollsize = 10;
const int pagesize = (staffheight + staffpadding) * 3;
const int doclength = topmargin + ((staffheight + staffpadding) * maxstaffs);

void CLeadSheet::Initialize(CWnd* pParent) 
{
	CRect rc;
	pParent->GetClientRect(&rc);
	rc.DeflateRect(5, 10, 5, 40);

	DWORD style = 
//				  WS_DLGFRAME     |
				  WS_CHILD		  |
				  WS_CLIPSIBLINGS |
//				  WS_VISIBLE	  |
				  WS_TABSTOP	  |
				  WS_VSCROLL
				  ;

#ifndef CEDITBASE
	CString strWndClass = AfxRegisterWndClass(
		0,
		theApp.LoadStandardCursor(IDC_ARROW),
		(HBRUSH) (COLOR_3DFACE + 1)
	);
#endif

	Create(
#ifndef CEDITBASE
		strWndClass, 
		0, 
#endif
		style, 
		rc,
		pParent,
		IDC_LEADSHEET
	);

	CDC* pDC = GetDC();

	m_pCDC = new CDC;
	m_pCDC->CreateCompatibleDC(pDC);

	GetClientRect(&m_SongRect);

	m_nWindowRows = m_SongRect.bottom + 1;

	m_SongRect.bottom = doclength;

	m_pCBitmap = new CBitmap;
	m_pCBitmap->CreateCompatibleBitmap(pDC, m_SongRect.Width(), m_SongRect.Height());

	m_pOldCBitmap = m_pCDC->SelectObject(m_pCBitmap);

	HideCaret();

//	SetCursor(m_hArrowCursor);

	m_pPage = (CSongPage*)pParent;
}

void CLeadSheet::NewSong()
{
	m_nChordsPerMeasure = 0;
	m_nMeasures = 0;
	m_nTopRow = 0;
	m_nBottomRow = 0;
	m_bChordOutlined = FALSE;
	m_nOutlinedChord = 0;
	m_MousePosition = CPoint(0,0);
	m_nAnchorMeasure = -1;
	m_nTerminalMeasure = -1;
	m_nSaveAnchorMeasure = -1;
	m_nSaveTerminalMeasure = -1;
	m_PrevRect = CRect(0,0,0,0);
	m_nSelectedMeasure = -1;
	m_nSelectedChord = -1;
	m_nBeatOffset = -1;
	m_bDragging = FALSE;
	m_bMarking = FALSE;
	m_bKeyboardMarking = FALSE;
	m_bCtrlDown = FALSE;
	m_bShiftDown = FALSE;
}

void CLeadSheet::BuildSong()
{
	CWaitCursor wait;
	m_nChordsPerMeasure = theSong.IsWaltz() ? 3 : 4;
	m_nMeasures = theSong.ChordCount() / m_nChordsPerMeasure;

	CDC& dc = *m_pCDC;

	// ---- clear the memory DC bitmap buffer
	dc.FillRect(&m_SongRect, theApp.m_pClearBrush);

	// ---- draw the title
	CFont* pOldFont = dc.SelectObject(&theApp.m_TitleFont);
	CSize size = dc.GetTextExtent(theSong.m_strTitle);
	int x = (m_SongRect.Width() - size.cx) / 2;
	dc.TextOut(x, 2, theSong.m_strTitle);
	m_TitleRect = CRect(x, 2, x + size.cx, 2 + size.cy);

	// ---- draw the tempo
	x = 5;
	int y = 3 + size.cy;
	dc.DrawIcon(x, y, theApp.m_hTempoIcon);

	dc.SelectObject(&theApp.m_ChordFont);
	CString strTempo;
	strTempo.Format(" = %d", theSong.m_nTempo);
	dc.TextOut(x + 10, y, strTempo);
	size = dc.GetTextExtent(strTempo);
	m_TempoRect = CRect(x, y, x + 10 + size.cx, y + 13);

	// ---- draw the staff
	CPen* pOldPen = dc.SelectObject(theApp.m_pBlackPen);

	int stafflength = m_SongRect.right - margin * 2;	// length of the staff

	for (int i = 0; i < m_SongRect.bottom; i += staffheight + staffpadding)	{
		// --- display the end caps of the staff
		int x = margin;
		int y = (topmargin + staffpadding + i);
		dc.MoveTo(x, y);
		dc.LineTo(x, y + staffheight);
		dc.MoveTo(x + stafflength, y);
		dc.LineTo(x + stafflength, y + staffheight);
		// ---- display the staff lines
		for (int j = 0; j < 5; j++)	{
			dc.MoveTo(x, y + j * staffspace);
			dc.LineTo(x + stafflength, y + j * staffspace);
		}
	}

	int nChordCount = theSong.ChordCount();
	int nPixelRow = topmargin + 5;
	int nPixelColumn = margin + 30;
	int nMeasure = 0;

	// ----- display the key signature
	static struct rootkey {
		BOOL isflat;
		int icons;
	} rk[] = {
		{0,3},	// A
		{1,2},	// Bb
		{0,5},	// B
		{0,0},	// C
		{1,5},	// Db
		{0,2},	// D
		{1,3},	// Eb
		{0,4},	// E
		{1,1},	// F
		{0,6},	// F#
		{0,1},	// G
		{1,4}	// Ab
	};

	if (nChordCount)	{
		if (theSong.m_Key.root == 0)	{
			theSong.m_Key = theSong.GetChord(nChordCount - 1);
			theSong.m_Key.attr &= (CChord::major | CChord::minor);
			theSong.m_Key.root &= 0xf;
		}
		if (theSong.m_Key.root)	{
			int rt = (theSong.m_Key.root & 0xf) - 1;
			if (theSong.m_Key.attr & CChord::minor)	{
				rt += 3;
				if (rt > 11)
					rt -= 12;
			}
			int x = nPixelColumn - 5;
			int y = nPixelRow + 8;

			if (theOptions.m_nClef)
				y += staffspace;

			m_KeyRect = CRect(x, y, x + 5 + rk[rt].icons*6, y + staffheight + 10);

			if (rk[rt].isflat)	{
				// one of the flat keys
				for (int i = 0; i < rk[rt].icons; i++)	{
					dc.DrawIcon(x, y, theApp.m_hFlatIcon);
					x += 6;
					y += (i&1) ? 10 : -7;
				}
			}
			else	{
				// one of the sharp keys
				for (int i = 0; i < rk[rt].icons; i++)	{
					dc.DrawIcon(x, y, theApp.m_hSharpIcon);
					x += 6;
					y -= (i&1) ? 10 : -7;
				}
			}


			nPixelColumn += 1 + rk[rt].icons * 6;
		}
	}

	Song::Style nPrevStyle = Song::nostyle;

	// ----- draw the chords
	for (i = 0; i < nChordCount; i += m_nChordsPerMeasure)	{

		CString strMeasure;
		CChord thisChord;
		CChord prevChord;

		int strokewidths[4];
		int chordwidths[4];

		int j;

		CSize size;
		for (j = 0; j < m_nChordsPerMeasure; j++)	{
			size = dc.GetTextExtent(strMeasure);
			strokewidths[j] = size.cx;

			CString strChord(" ");
			thisChord = theSong.GetChord(i + j);
			if (thisChord != prevChord)	{
				theSong.BuildChordDisplay(strChord, thisChord, theOptions.m_nAbbreviated);
				prevChord = thisChord;
			}
			strChord += " ";
			strMeasure += strChord;

			size = dc.GetTextExtent(strChord);
			strokewidths[j] += size.cx / 2;
			chordwidths[j] = size.cx;
		}

		int nFactor = 0;
		const Song::Event& rEvent = theSong.GetEvent(i);
		if ((rEvent.m_nEventType & Song::beginrepeat) || (rEvent.m_nEventType & Song::endrepeat))
			nFactor = 5;
		else if (rEvent.m_nEventType & Song::passage)
			nFactor = 3;

		const int nEndingAdj = 5;

		if (rEvent.m_nEventType & Song::ending)
			nFactor += nEndingAdj;

		nMeasure = i / m_nChordsPerMeasure;

		size = dc.GetTextExtent(strMeasure);
		if (nPixelColumn + size.cx + nFactor > stafflength + margin)	{
			if (nMeasure != 0)
				m_Measures[nMeasure-1].right = stafflength + margin + 1;
			nPixelColumn = margin;
			nPixelRow += staffheight + staffpadding;
		}

		// --- draw style change
		if (i == 0 || rEvent.m_nEventType & Song::style)	{
			Song::Style nStyle = rEvent.m_nStyleChange;
			if (nStyle != nPrevStyle)	{
				nPrevStyle = nStyle;
				CString strStyle = theSong.StyleNotation(nStyle);
				int x = nPixelColumn + nFactor + 5;
				int y = nPixelRow + staffheight + 14;
				dc.SelectObject(&theApp.m_StyleFont);
				CSize size = dc.GetTextExtent(strStyle);
				CRect rc(x, y+1, x+size.cx, y+size.cy-1);
				dc.ExtTextOut(x, y, ETO_CLIPPED, &rc, strStyle, 0);
			}
		}

		// --- remember these values for later
		int nEndingX = nPixelColumn;
		int nEndingY = staffpadding + nPixelRow - staffspace;

		if (rEvent.m_nEventType & Song::beginrepeat)	{
			// --- draw begin repeat sign

			int x = nPixelColumn + 2;
			int y = staffpadding + nPixelRow - staffspace;

			dc.SelectObject(theApp.m_pBoldPen);
			dc.MoveTo(x, y+1);
			dc.LineTo(x, y + staffheight - 1);

			x += 3;
			dc.SelectObject(theApp.m_pBlackPen);
			dc.MoveTo(x, y);
			dc.LineTo(x, y + staffheight);

			x += 2;
			y = staffpadding + nPixelRow + 2;;

			for (int dot = 0; dot < 2; dot++)	{
				for (int yy = 0; yy < 2; yy++)
					for (int xx = 0; xx < 2; xx++)
						dc.SetPixel(x + xx, y + yy, RGB(0,0,0));
				y += staffspace;
			}

			nPixelColumn += 5;

		}
		else	{
			// ---- draw the measure separator on the staff
			int y = staffpadding + nPixelRow - staffspace;
			dc.MoveTo(nPixelColumn, y);
			dc.LineTo(nPixelColumn, y + staffheight);

			if (rEvent.m_nEventType & Song::passage)	{
				// --- draw passage sign
				nPixelColumn += 3;
				dc.MoveTo(nPixelColumn, y);
				dc.LineTo(nPixelColumn, y + staffheight);
			}
		}

		if (rEvent.m_nEventType & Song::ending)
			nPixelColumn += nEndingAdj;

		// --- post the measure rectangle for block marking
		int x = nPixelColumn;
		int y = nPixelRow+2;
		int x1 = x + size.cx;
		int y1 = y + staffheight + staffpadding;

		if (rEvent.m_nEventType & Song::beginrepeat)
			x -= 5;
		if (rEvent.m_nEventType & Song::ending)
			x -= 5;
		if (rEvent.m_nEventType & Song::endrepeat)
			x1 += 5;
			
		m_Measures[nMeasure] = CRect(x, y, x1, y1);

		// --- post the chords' window rectangles for mouse selection
		CRect crc(nPixelColumn, nPixelRow+2, 0, nPixelRow + staffheight + staffpadding - 4);
		for (j = 0; j < m_nChordsPerMeasure; j++)	{
			crc.right = crc.left + chordwidths[j];
			if (j == 0)
				crc.left += 3;
			m_Chords[i+j] = crc;
			crc.left = crc.right;
		}

		// ---- draw the beat strokes in the staff
		CPen* pOldPen = dc.SelectObject(theApp.m_pBlackPen);

		y = staffpadding + nPixelRow - staffspace;

		BOOL b1stHalf = theSong.IsRest(i) && theSong.IsRest(i+1);
		BOOL b2ndHalf = theSong.IsWaltz() ? FALSE : (theSong.IsRest(i+2) && theSong.IsRest(i+3));
		BOOL bWhole   = b1stHalf && b2ndHalf;
		
		for (j = 0; j < m_nChordsPerMeasure; j++)	{
			x = nPixelColumn + strokewidths[j];
			if (!theSong.IsRest(i+j))	{
				dc.MoveTo(x, y + 5);
				dc.LineTo(x-2, y + staffheight - 5);
			}
			else	{
				if ((j < 2 && !b1stHalf)  || (j > 1 && !b2ndHalf))
					dc.DrawIcon(x-2, y+3, theApp.m_hQtrIcon);
			}
			m_Beats[i+j] = CPoint(x, y + 5);
			m_bRests[i+j] = j < 2 ? b1stHalf : b2ndHalf;
		}

		if (bWhole)	{
			int x = m_Measures[nMeasure].left - 2 + m_Measures[nMeasure].Width()/2;
			int y = m_Measures[nMeasure].top + 19;
			dc.FillSolidRect(x, y, 5, 3, RGB(0,0,0));
			dc.SetBkColor(RGB(255,255,2550));
		}
		else if (b1stHalf)	{
			int x = m_Measures[nMeasure].left + 2 + m_Measures[nMeasure].Width()/4;
			int y = m_Measures[nMeasure].top + 20;
			dc.FillSolidRect(x, y, 5, 3, RGB(0,0,0));
			dc.SetBkColor(RGB(255,255,2550));
		}
		else if (b2ndHalf)	{
			int x = m_Measures[nMeasure].left - 2 + m_Measures[nMeasure].Width()*3/4;
			int y = m_Measures[nMeasure].top + 20;
			dc.FillSolidRect(x, y, 5, 3, RGB(0,0,0));
			dc.SetBkColor(RGB(255,255,2550));
		}

		dc.SelectObject(&theApp.m_ChordFont);
		// ------ draw the measure of chords above the staff
		dc.TextOut(nPixelColumn + 3, nPixelRow + 2, strMeasure);

		if (theOptions.m_nAbbreviated)	{
			// ---- Maj7 chord deltas
			CString str(strMeasure);
			int ndx = str.Find('w');
			int chx = nPixelColumn - 4;
			int chy = nPixelRow + 6;
			dc.SelectObject(theApp.m_pBlackPen);
			while (ndx != -1)	{
				CString strn = str.Left(ndx + 1);
				CSize size = dc.GetTextExtent(strn);
				chx += size.cx;
				// ---- clear the 'w'
				CRect crc(chx, chy, chx + 7, chy + 6);
				dc.FillRect(&crc, theApp.m_pClearBrush);
				// ---- draw the delta
				dc.DrawIcon(chx, chy-1, theApp.m_hDeltaIcon);
				str = str.Right(str.GetLength() - ndx - 1);
				ndx = str.Find('w');
			}
			// ---- dim chord o's
			ndx = str.Find('o');
			chx = nPixelColumn;
			chy = nPixelRow + 5;
			while (ndx != -1)	{
				CString strn = str.Left(ndx + 1);
				CSize size = dc.GetTextExtent(strn);
				chx += size.cx;
				// ---- clear the 'o'
				CRect crc(chx - 2, chy + 2, chx + 2, chy + 7);
				dc.FillRect(&crc, theApp.m_pClearBrush);
				// ---- draw the superscripted 'o'
				CRect orc(chx - 3, chy, chx + 1, chy + 4);
				dc.Ellipse(orc);
				str = str.Right(str.GetLength() - ndx - 1);
				ndx = str.Find('o');
			}
		}

		if (rEvent.m_nEventType & Song::ending)	{
			// ---- draw the ending notation
			dc.SelectObject(theApp.m_pBlackPen);
			dc.MoveTo(nEndingX, nEndingY);
			nEndingY -= staffpadding - 7;

			CString strEnding;
			strEnding.Format("%d", rEvent.m_nEndingNumber);
			dc.SelectObject(&theApp.m_StyleFont);
			dc.TextOut(nEndingX + 1, nEndingY, strEnding);
			dc.SelectObject(&theApp.m_ChordFont);

			dc.LineTo(nEndingX, nEndingY);
			dc.LineTo(nEndingX + size.cx + nFactor, nEndingY);
		}

		nPixelColumn += size.cx;

		static int nRepeatRow, nRepeatColumn;
		// ---- post end repeat sign

		if (i > 0)	{
			int j = i - m_nChordsPerMeasure;
			for (;;)	{
				if (theSong.GetEvent(j).m_nEventType & Song::endrepeat)	{

					if (nRepeatRow != nPixelRow)
						nRepeatColumn = stafflength + margin - 5;
					int x = nRepeatColumn-1;
					int y = staffpadding + nRepeatRow + 2;;

					for (int dot = 0; dot < 2; dot++)	{
						for (int yy = 0; yy < 2; yy++)
							for (int xx = 0; xx < 2; xx++)
								dc.SetPixel(x + xx, y + yy, RGB(0,0,0));
						y += staffspace;
					}

					dc.SelectObject(theApp.m_pBlackPen);
					x = nRepeatColumn + 2;
					y = staffpadding + nRepeatRow - staffspace;
					dc.MoveTo(x, y);
					dc.LineTo(x, y + staffheight);

					x += 3;
					dc.SelectObject(theApp.m_pBoldPen);
					dc.MoveTo(x, y+1);
					dc.LineTo(x, y + staffheight-1);
				}
				if (j == (nChordCount/m_nChordsPerMeasure - 2) * m_nChordsPerMeasure)	{
					j += m_nChordsPerMeasure;
					nRepeatRow = nPixelRow;
					nRepeatColumn = nPixelColumn;
				}
				else
					break;
			}
		}

		if (rEvent.m_nEventType & Song::endrepeat)	{
			nRepeatRow = nPixelRow;
			nRepeatColumn = nPixelColumn;
			nPixelColumn += 5;
		}

		dc.SelectObject(pOldPen);

	}

	m_nBottomRow = nPixelRow + staffheight + staffpadding;


	const Song::Event& rEvent = theSong.GetEvent(m_nChordsPerMeasure * nMeasure);

	if (nChordCount)	{
		int x = nPixelColumn + 1;
		int y = (staffpadding + nPixelRow - staffspace);
		// ---- rect for selecting past the last measure
		CRect mrc(x, y, x + 8, y + staffheight + 7);
		m_Measures[nChordCount / m_nChordsPerMeasure] = mrc;
		if ((rEvent.m_nEventType & Song::endrepeat) == 0)	{
			// --- display the closing staff endcap
			x++;
			dc.SelectObject(theApp.m_pBlackPen);
			dc.MoveTo(x, y);
			dc.LineTo(x, y + staffheight);

			x += 2;
			dc.SelectObject(theApp.m_pBoldPen);
			dc.MoveTo(x, y + 1);
			dc.LineTo(x, y + staffheight-1);

			x++;
		}

		// ---- clear to the end of the staff
		CRect crc(x, y, stafflength + margin + 1, y + staffheight);
		dc.FillRect(&crc, theApp.m_pClearBrush);

		y += staffheight;
		if (y < m_SongRect.bottom)	{
			// ---- clear to the end of the document
			CRect rc(m_SongRect);
			rc.top = y + 8;
			dc.FillRect(&rc, theApp.m_pClearBrush);
		}
		SetScrollRange(SB_VERT, 0, nPixelRow);

	}

	// ---- draw the clef icon
	x = margin;
	y = topmargin + staffpadding - 5;
	dc.DrawIcon(x, y, 
		theSong.IsWaltz() ? 
			(theOptions.m_nClef ? theApp.m_h34BassIcon : theApp.m_h34TrebleIcon) : 
			(theOptions.m_nClef ? theApp.m_h44BassIcon : theApp.m_h44TrebleIcon));

	m_ClefRect = CRect(x + 1, y, x + 13, y + staffheight + 10);
	
	dc.SelectObject(pOldPen);
	dc.SelectObject(pOldFont);
}

void CLeadSheet::ScrollTo(UINT nPos)
{
	m_nTopRow = nPos;
	SetScrollPos(SB_VERT, nPos);
	Invalidate();
}
void CLeadSheet::ScrollDown()
{
	if (m_nTopRow > 0)	{
		CRect rc;
		GetClientRect(&rc);
		rc.bottom -= scrollsize;
		if (m_bHasFocus)	{
			rc.top++;
			--rc.bottom;
		}
		int nsize = m_nTopRow < scrollsize ? m_nTopRow : scrollsize;

		ScrollWindow(0, nsize, &rc);
		m_nTopRow -= nsize;
		SetScrollPos(SB_VERT, m_nTopRow);
	}
}
void CLeadSheet::ScrollUp()
{
	if (m_nTopRow + m_nWindowRows < m_nBottomRow)	{
		CRect rc;
		GetClientRect(&rc);
		rc.top += scrollsize;
		if (m_bHasFocus)	{
			rc.top++;
			--rc.bottom;
		}

		ScrollWindow(0, -scrollsize, &rc);
		m_nTopRow += scrollsize;
		SetScrollPos(SB_VERT, m_nTopRow);
	}
}
void CLeadSheet::PageUp()
{
	if (m_nTopRow > 0)	{
		m_nTopRow -= pagesize;
		if (m_nTopRow < 0)
			m_nTopRow = 0;
		SetScrollPos(SB_VERT, m_nTopRow);
		Invalidate();
	}
}
void CLeadSheet::PageDown()
{
	if (m_nTopRow + m_nWindowRows < m_nBottomRow)	{
		m_nTopRow += pagesize;
		SetScrollPos(SB_VERT, m_nTopRow);
		Invalidate();
	}
}
void CLeadSheet::StartPlaying()
{
	CDC* pDC = GetDC();
	SelectChord(pDC, -1);
	SelectMeasure(pDC, -1);

	m_nCountOff = 0;
	m_nBeatOffset = -1;
	int nStart, nStop, nCount;
	GetBlockMarkers(nStart, nStop, nCount);

	SaveBlock();
	UnmarkBlock();

	m_bCtrlDown = FALSE;
	m_bShiftDown = FALSE;

	if (!m_PrevRect.IsRectNull())	{
		CRect prc = m_PrevRect;
		prc.top -= m_nTopRow;
		prc.bottom -= m_nTopRow;
		CDC* pDC = GetDC();
		pDC->DrawFocusRect(prc);
		m_PrevRect = CRect(0,0,0,0);
	}
	m_bChordOutlined = FALSE;

	if (nStart == -1)
		ScrollTo(0);
	else	{
		int y = m_Measures[nStart].top - (staffheight + staffpadding);
		if (y < 0)
			y = 0;
		if (y < m_nTopRow || y >= m_nTopRow + m_nWindowRows)
			ScrollTo(y);
	}
}
inline CPoint CLeadSheet::IconPoint(int nMeasureNo)
{
	CPoint pt;
	pt.x = m_Measures[nMeasureNo].left;
	pt.y = m_Measures[nMeasureNo].bottom-7-m_nTopRow;
	return pt;
}
void CLeadSheet::ScrollStaff(int nChord, BOOL bGoingDown)
{
	int y = m_Beats[nChord].y;
	if (y < m_nTopRow + staffpadding || y > m_nTopRow + m_nWindowRows - (staffheight + staffpadding))  {
		if (bGoingDown && !(y < m_nTopRow + staffpadding))
			ScrollTo(m_nTopRow + staffheight + staffpadding);
		else
			ScrollTo(y - topmargin);
		UpdateWindow();
	}
}
void CLeadSheet::SelectChord(int nChordNo, BOOL bGoingDown)
{
	if (nChordNo != -1)
		ScrollStaff(nChordNo, bGoingDown);
	CDC* pDC = GetDC();
	SelectChord(pDC, nChordNo);
	SelectMeasure(pDC, nChordNo == -1 ? nChordNo : nChordNo / m_nChordsPerMeasure);
}
void CLeadSheet::SelectMeasure(int nMeasureNo)
{
	CDC* pDC = GetDC();
	if (nMeasureNo >= 0 && nMeasureNo < m_nMeasures)	{
		ScrollStaff(nMeasureNo * m_nChordsPerMeasure, TRUE);
		SelectChord(pDC, nMeasureNo * m_nChordsPerMeasure);
	}
	else
		SelectChord(pDC, -1);
	SelectMeasure(pDC, nMeasureNo);
}
void CLeadSheet::SelectMeasure(CDC* pCDC, int nMeasureNo)
{
	if (nMeasureNo != m_nSelectedMeasure)	{
		if (m_nSelectedMeasure != -1 && ((!m_bMarking && !m_bKeyboardMarking) || !IsMeasureInBlock(m_nSelectedMeasure)))	{
			CPoint pt = IconPoint(m_nSelectedMeasure);
			CRect rc(pt.x, pt.y, pt.x+5, pt.y+6);
			pCDC->FillRect(&rc, theApp.m_pClearBrush);
		}
		ASSERT (m_pPage != 0);
		if (nMeasureNo != -1)	{
			if (!m_bMarking && !m_bKeyboardMarking)	{
				CPoint pt = IconPoint(nMeasureNo);
				pCDC->DrawIcon(pt.x, pt.y, theApp.m_hMeasureIcon);
			}
			if (!theSong.IsPlaying())	{
				if (m_nSelectedChord != -1 && m_nSelectedChord < theSong.ChordCount())	{
					m_pPage->EnableRepeats();
					m_pPage->EnableStyleAndEnding();
				}
				else	{
					m_pPage->DisableRepeats();
					m_pPage->DisableStyleAndEnding();
				}
			}
		}
		else	{
			m_pPage->DisableRepeats();
			m_pPage->DisableStyleAndEnding();
		}
		m_nSelectedMeasure = nMeasureNo;
		if (CanPaste())
			m_pPage->EnablePaste();
		else
			m_pPage->DisablePaste();
	}
}
void CLeadSheet::SelectChord(CDC* pCDC, int nChordNo)
{
	if (nChordNo != m_nSelectedChord)	{
		CPoint pt;
		CDC* pDC = GetDC();
		if (m_nSelectedChord != -1 && ((!m_bMarking && !m_bKeyboardMarking) || !IsChordInBlock(m_nSelectedChord)))
			DrawStroke(pDC, m_nSelectedChord, theApp.m_pBlackPen);
		ASSERT (m_pPage != 0);
		if (nChordNo != -1)	{
			if (!m_bMarking && !m_bKeyboardMarking)
				DrawStroke(pDC, nChordNo, theApp.m_pRedPen);
			if (!theSong.IsPlaying())	{
				m_pPage->EnableRests();
				m_pPage->EnableRepeats();
				m_pPage->EnableStyleAndEnding();
			}
		}
		else	{
			m_pPage->DisableRests();
			m_pPage->DisableRepeats();
			m_pPage->DisableStyleAndEnding();
		}
		m_nSelectedChord = nChordNo;
	}
}

void CLeadSheet::DrawStroke(CDC* pDC, int nOffset, CPen* pPen)
{
	if (!m_bRests[nOffset])	{
		int x = m_Beats[nOffset].x;
		int y = m_Beats[nOffset].y - m_nTopRow;
		if (theSong.IsRest(nOffset))
			pDC->DrawIcon(x-2, y-2, pPen == theApp.m_pBlackPen ? theApp.m_hQtrIcon : theApp.m_hRedQtrIcon);
		else	{
			CPen* pOldPen = pDC->SelectObject(pPen);

			pDC->MoveTo(x, y+1);
			pDC->LineTo(x-2, y + staffheight - 11);

			if (pPen == theApp.m_pBlackPen)
				pDC->SelectObject(theApp.m_pClearPen);

			pDC->MoveTo(x-1, y+1);
			pDC->LineTo(x-3, y + staffheight - 11);

			pDC->MoveTo(x+1, y+1);
			pDC->LineTo(x-1, y + staffheight - 11);

			if (pPen == theApp.m_pBlackPen)	{
				// --- fix the staff line where the clear stroke took out pixels
				pDC->SelectObject(theApp.m_pBlackPen);

				pDC->MoveTo(x-2, y+staffspace);
				pDC->LineTo(x+1, y+staffspace);
			}

			pDC->SelectObject(pOldPen);
		}
	}
}

BOOL CLeadSheet::IsMeasureInBlock(int nMeasure)
{
	if (nMeasure >= 0 && m_nAnchorMeasure != -1)	{
		int nStart, nStop, nCount;
		GetBlockMarkers(nStart, nStop, nCount);
		if (nMeasure >= nStart && nMeasure <= nStop)
			return TRUE;
	}
	return FALSE;
}
void CLeadSheet::RestoreBlock()
{
	m_nAnchorMeasure = m_nSaveAnchorMeasure;
	m_nTerminalMeasure = m_nSaveTerminalMeasure;
	int nStart, nStop, nCount;
	GetBlockMarkers(nStart, nStop, nCount);
	while (nCount--)
		InvertMeasure(nStart++);
}

void CLeadSheet::Countoff(BOOL bOnOff)
{
	CDC* pDC = GetDC();
	DrawStroke(pDC, m_nCountOff, bOnOff ? theApp.m_pRedPen : theApp.m_pBlackPen);
	if (!bOnOff)	
		if (++m_nCountOff == (theSong.IsWaltz() ? 3 : 4))
			m_nCountOff = 0;
}

void CLeadSheet::Beat(int nBeat)
{
	if (theSong.ChordCount() && !theApp.m_bBuildingMidiFile)	{
		m_nBeatOffset = theSong.CurrentChordNo();
		if (m_nBeatOffset < theSong.ChordCount())
			SelectChord(m_nBeatOffset, TRUE);
	}
}

void CLeadSheet::StopPlaying()
{
	CDC* pDC = GetDC();
	SelectChord(pDC, -1);
	SelectMeasure(pDC, -1);
	RestoreBlock();
	Invalidate();
}

// --- player struck a chord while viewing the lead sheet
void CLeadSheet::ChordEvent(CChord chord)
{
	if (m_Chord.root == 0)
		SetTimer(1, 100, 0); // waits for the chord to settle in (all the fingers get down)
	m_Chord = chord;
}

void CLeadSheet::ProcessChord()
{
	if (m_nSelectedChord != -1)	{
		int sel = m_nSelectedChord;

		CChord OrigChord = theSong.GetChord(sel);
		if (OrigChord != m_Chord)	{
			theSong.ReplaceChord(sel, m_Chord, TRUE);

			ASSERT (m_pPage != 0);
			m_pPage->EnableUndo();

			while (++sel % m_nChordsPerMeasure)	{
				CChord crd = theSong.GetChord(sel);
				if (crd != OrigChord)
					break;
				theSong.ReplaceChord(sel, m_Chord, FALSE);
			}

			m_PrevRect = CRect(0,0,0,0);
			RebuildDisplay();

			if (m_bChordOutlined)	{
				CDC* pDC = GetDC();
				CRect prc = m_Chords[m_nOutlinedChord];
				m_PrevRect = prc;
				prc.top -= m_nTopRow;
				prc.bottom -= m_nTopRow;
				pDC->DrawFocusRect(prc);
			}
		}
	}
	m_Chord = CChord();
}
void CLeadSheet::RebuildDisplay()
{
	BuildSong();
	Invalidate();
}

void CLeadSheet::ReSelectChordAndMeasure()
{
	UpdateWindow();
	SelectChord(m_nSelectedChord);
}

void CLeadSheet::ToggleQuarterRest()
{
	ToggleEvent(m_nSelectedChord, Song::rest);
	RebuildDisplay();
}
void CLeadSheet::ToggleHalfRest()
{
	int nChord = m_nSelectedChord & ~1;
	ToggleEvent(nChord++, Song::rest);
	ToggleEvent(nChord, Song::rest);
	RebuildDisplay();
}
void CLeadSheet::ToggleWholeRest()
{
	int nChord = m_nSelectedChord & ~3;
	ToggleEvent(nChord++, Song::rest);
	ToggleEvent(nChord++, Song::rest);
	ToggleEvent(nChord++, Song::rest);
	ToggleEvent(nChord, Song::rest);
	RebuildDisplay();
}

void CLeadSheet::ToggleEvent(int nEvent, Song::EventType evType)
{
	if (theSong.ChordCount())	{
		if ((theSong.GetEvent(nEvent).m_nEventType & evType) != 0)
			theSong.ClearEvent(nEvent, evType);
		else
			theSong.SetEvent(nEvent, evType);
	}
}

void CLeadSheet::TogglePassage()
{
	int nEvent = m_nSelectedMeasure * m_nChordsPerMeasure;
	if ((theSong.GetEvent(nEvent).m_nEventType & Song::beginrepeat) == 0)	{
		if (nEvent == 0 || (theSong.GetEvent(nEvent-1).m_nEventType & Song::endrepeat) == 0)	{
			ToggleEvent(nEvent, Song::passage);
			RebuildDisplay();
		}
	}
}

void CLeadSheet::ToggleBeginRepeat()
{
	if (m_nAnchorMeasure != -1)
		SetRepeats();
	else	{
		int nEvent = m_nSelectedMeasure * m_nChordsPerMeasure;
		if (nEvent < theSong.ChordCount())	{
			ToggleEvent(nEvent, Song::beginrepeat);
//			if ((theSong.GetEvent(nEvent).m_nEventType & Song::beginrepeat) == 0)
//				theSong.ClearEvent(nEvent, Song::beginwithending, FALSE);
//			else	{
				// --- if there is a passage mark this measure, clear it
				theSong.ClearEvent(nEvent, Song::passage, FALSE);
//				// --- setting a begin repeat, see if there is a matching ending
//				int nBegEvent = nEvent;
//				while (nEvent < theSong.ChordCount())	{
//					if (theSong.GetEvent(nEvent).m_nEventType & Song::ending)	{
//						theSong.SetEvent(nBegEvent, Song::beginwithending, FALSE);
//						break;
//					}
//					else if (theSong.GetEvent(nEvent).m_nEventType & Song::endrepeat)
//						break;
//					else if (nEvent != nBegEvent && (theSong.GetEvent(nEvent).m_nEventType & Song::beginrepeat))
//						break;
//					nEvent++;
//				}
//			}
			RebuildDisplay();
		}
	}
}
void CLeadSheet::ToggleEndRepeat()
{
	if (m_nAnchorMeasure != -1)
		SetRepeats();
	else	{
		int nEvent = m_nSelectedMeasure * m_nChordsPerMeasure;
		if (nEvent == theSong.ChordCount())
			--nEvent;
		ToggleEvent(nEvent, Song::endrepeat);
//		if (theSong.GetEvent(nEvent).m_nEventType & Song::endrepeat)	{
			// --- if there is a passage mark next measure, clear it
			if (nEvent < m_nMeasures * m_nChordsPerMeasure)
				theSong.ClearEvent(nEvent + m_nChordsPerMeasure, Song::passage, FALSE);
			// --- this might cancel out an ending-terminated begin repeat
//			while (nEvent >= 0)	{
//				if (theSong.GetEvent(nEvent).m_nEventType & Song::beginrepeat)	{
//					theSong.ClearEvent(nEvent, Song::beginwithending, FALSE);
//					break;
//				}
//				else if (theSong.GetEvent(nEvent).m_nEventType & Song::ending)
//					break;
//				--nEvent;
//			}
//		}
		RebuildDisplay();
	}
}
void CLeadSheet::ToggleEnding()
{
	int nEvent = m_nSelectedMeasure * m_nChordsPerMeasure;
	if (nEvent < theSong.ChordCount())	{
		if ((theSong.GetEvent(nEvent).m_nEventType & Song::ending) == 0)	{
			// --- setting the ending event
			CEndingDlg dlg;
			if (dlg.DoModal() == IDCANCEL)
				return;
			ToggleEvent(nEvent, Song::ending);
			theSong.SetEndingNumber(nEvent, dlg.m_nEnding + 1);
		}
		else	{
			ToggleEvent(nEvent, Song::ending);
			theSong.SetEndingNumber(nEvent, 0);
		}
//		// --- toggled an ending, see if there is a matching begin repeat
//
//		int nEndEvent = nEvent;
//		while (--nEvent >= 0)	{
//			if (theSong.GetEvent(nEvent).m_nEventType & Song::beginrepeat)	{
//				if (theSong.GetEvent(nEndEvent).m_nEventType & Song::ending)
//					theSong.SetEvent(nEvent, Song::beginwithending, FALSE);
//				else
//					theSong.ClearEvent(nEvent, Song::beginwithending, FALSE);
//				break;
//			}
//			else if (theSong.GetEvent(nEvent).m_nEventType & Song::endrepeat)
//				break;
//		}

		RebuildDisplay();
	}
}
void CLeadSheet::SetRepeats()
{
	int nStart, nStop, nCount;
	GetBlockMarkers(nStart, nStop, nCount);
	nStart *= m_nChordsPerMeasure;
	nStop *= m_nChordsPerMeasure;
	theSong.SetEvent(nStart, Song::beginrepeat);
	// --- if there is a passage mark on begin repeat measure, clear it
	theSong.ClearEvent(nStart, Song::passage, FALSE);
	theSong.SetEvent(nStop, Song::endrepeat, FALSE);
	// --- if there is a passage mark on next measure past end repeat, clear it
	if (nStop < m_nMeasures * m_nChordsPerMeasure)
		theSong.ClearEvent(nStop + m_nChordsPerMeasure, Song::passage, FALSE);
	UnmarkBlock();
	RebuildDisplay();
}
BOOL CLeadSheet::ChangeTitle()
{
	CDlgSongTitle dlgTitle;
	dlgTitle.m_strSongTitle = theSong.m_strTitle;
	if (dlgTitle.DoModal() == IDOK)	{
		theSong.SetTitle(dlgTitle.m_strSongTitle);
		m_PrevRect = CRect(0,0,0,0);
		RebuildDisplay();
		return TRUE;
	}
	return FALSE;
}
int CLeadSheet::FirstMeasure() const
{
	int nStart, nStop, nCount;
	GetBlockMarkers(nStart, nStop, nCount);
	if (nStart != -1)
		return nStart;
	return 0;
}

int CLeadSheet::LastMeasure() const
{
	int nStart, nStop, nCount;
	GetBlockMarkers(nStart, nStop, nCount);
	if (nStop == -1)
		nStop = theSong.ChordCount() / m_nChordsPerMeasure - 1;
	return nStop < 0 ? 0 : nStop;
}

/////////////////////////////////////////////////////////////////////////////
// CLeadSheet message handlers

void CLeadSheet::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CRect rc;
	GetClientRect(&rc);

	dc.BitBlt(0, 0, rc.Width(), rc.Height(), m_pCDC, 0, m_nTopRow, SRCCOPY);

	if (m_nAnchorMeasure == -1)	{

		int nMeasure = m_nSelectedMeasure;
		int nChord = m_nSelectedChord;
		m_nSelectedMeasure = -1;
		m_nSelectedChord = -1;

		//---- repaint the selected red measure indicator and beat stroke
		SelectChord(&dc, nChord);
		SelectMeasure(&dc, nMeasure);

		if (!m_PrevRect.IsRectNull())	{
			// ---- repaint the chord selection rectangle
			CRect prc = m_PrevRect;
			prc.top -= m_nTopRow;
			prc.bottom -= m_nTopRow;
			dc.DrawFocusRect(prc);
		}
	}

	if (m_bHasFocus)
		// ---- draw the focus border
		dc.FrameRect(&rc, theApp.m_pBorderBrush);
}

void CLeadSheet::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	switch(nSBCode)	{
		case SB_TOP:
			ScrollTo(0);
			break;
		case SB_THUMBTRACK:
			ScrollTo(nPos);
			break;
		case SB_LINEDOWN:
			ScrollUp();
			break;
		case SB_LINEUP:
			ScrollDown();
			break;
		case SB_PAGEDOWN:
			PageDown();
			break;
		case SB_PAGEUP:
			PageUp();
			break;
		default:
			break;
	}
}

void CLeadSheet::InvertMeasure(int nMeasure)
{
	CRect crc = m_Measures[nMeasure];
	m_pCDC->PatBlt(crc.left,crc.top,crc.Width(),crc.Height(),DSTINVERT);
	crc.top -= m_nTopRow;
	crc.bottom -= m_nTopRow;
	::InvalidateRect(m_hWnd, crc, TRUE);
}

void CLeadSheet::AdjustBlockDisplay(int nMeasure)
{
	while (nMeasure != m_nTerminalMeasure)	{
		if (m_nTerminalMeasure == -1)	{
			m_nTerminalMeasure = m_nAnchorMeasure;
			InvertMeasure(m_nTerminalMeasure);
		}
		else if ((m_nTerminalMeasure >= m_nAnchorMeasure && nMeasure > m_nTerminalMeasure) ||
				 (m_nTerminalMeasure <= m_nAnchorMeasure && nMeasure < m_nTerminalMeasure))	{
			// --- moving away from anchor
			if (nMeasure < m_nTerminalMeasure)
				--m_nTerminalMeasure;
			else
				m_nTerminalMeasure++;
			InvertMeasure(m_nTerminalMeasure);
		}
		else	{
			// --- moving toward anchor
			InvertMeasure(m_nTerminalMeasure);
			if (nMeasure < m_nTerminalMeasure)
				--m_nTerminalMeasure;
			else
				m_nTerminalMeasure++;
		}
	}
	UpdateWindow();
}

void CLeadSheet::OnMouseMove(UINT nFlags, CPoint point)
{
	if (!theSong.IsPlaying())	{
		m_MousePosition = point;
		CPoint pt(point);
		pt.y += m_nTopRow;

		CDC* pDC = GetDC();

		int nMeasure;

		for (nMeasure = 0; nMeasure < m_nMeasures+1; nMeasure++)
			if (m_Measures[nMeasure].PtInRect(pt))
				break;
		if (nMeasure == m_nMeasures+1)
			nMeasure = -1;

		if (m_bClicked)	{
			// --- a measure was clicked earlier, now the mouse has been moved

			if (nMeasure > -1 && nMeasure < m_nMeasures && nMeasure != m_nAnchorMeasure)	{
				// --- the measure moved into is not the original clicked measure, dragging now
				m_bClicked = FALSE;
				m_bMarking = TRUE;
				ASSERT (m_pPage != 0);
				m_pPage->EnableCutCopy();
			}
		}
		if (m_bMarking || m_bDragging)	{
			if (point.y < 0)	{
				ScrollDown();
				pt.y = m_nTopRow;
				SetTimer(0, 1, 0);
			}
			else if (point.y > m_nWindowRows)	{
				ScrollUp();
				pt.y = m_nTopRow + m_nWindowRows - 1;
				SetTimer(0, 1, 0);
			}
			if (m_bDragging)
				SelectMeasure(pDC, (IsMeasureInBlock(nMeasure)) ? -1 : nMeasure);
			else if (nMeasure > -1 && nMeasure < m_nMeasures)
				AdjustBlockDisplay(nMeasure);
		}
		if (!m_bClicked && !m_bMarking && m_nAnchorMeasure == -1)	{
			int i;
			CRect rc(0,0,0,0);
			BOOL bSelected = FALSE;
			if (m_TitleRect.PtInRect(point))
				rc = m_TitleRect;
			else if (m_TempoRect.PtInRect(point))
				rc = m_TempoRect;
			else if (m_KeyRect.PtInRect(point))
				rc = m_KeyRect;
			else if (m_ClefRect.PtInRect(point))
				rc = m_ClefRect;
			else	{
				for (i = 0; i < theSong.ChordCount(); i++)	{
					CRect crc = m_Chords[i];
					if (crc.PtInRect(pt))	{
						rc = crc;
						bSelected = TRUE;
						break;
					}
				}
			}

			if (!rc.IsRectNull())	{
				if (rc != m_PrevRect)	{
					if (!m_PrevRect.IsRectNull())	{
						CRect prc = m_PrevRect;
						prc.top -= m_nTopRow;
						prc.bottom -= m_nTopRow;
						pDC->DrawFocusRect(prc);
					}
					CRect trc = rc;
					trc.top -= m_nTopRow;
					trc.bottom -= m_nTopRow;
					pDC->DrawFocusRect(trc);
					m_PrevRect = rc;
					m_bChordOutlined = bSelected;
					m_nOutlinedChord = i;
				}
			}
			else if (!m_PrevRect.IsRectNull())	{
				CRect prc = m_PrevRect;
				prc.top -= m_nTopRow;
				prc.bottom -= m_nTopRow;
				pDC->DrawFocusRect(prc);
				m_PrevRect = CRect(0,0,0,0);
				m_bChordOutlined = FALSE;
			}
		}
		if (CanPaste())
			m_pPage->EnablePaste();
	}
}

void CLeadSheet::UnmarkBlock()
{
	if (m_nAnchorMeasure != -1)	{
		// ---- turn off the marked block in the bitmap
		int nStart, nStop, nCount;
		GetBlockMarkers(nStart, nStop, nCount);
		do
			InvertMeasure(nStart++);
		while (nStart <= nStop);

		m_bMarking = FALSE;
		m_bKeyboardMarking = FALSE;
		m_nAnchorMeasure = -1;
		m_nTerminalMeasure = -1;
		ASSERT (m_pPage != 0);
		m_pPage->DisableCutCopy();
		m_pPage->DisableRepeats();
		m_pPage->DisablePaste();
		UpdateWindow();
	}
}
void CLeadSheet::SetTempo()
{
	SelectChord(-1);
	CTempoDlg dlgTempo;
	if (dlgTempo.DoModal() == IDOK)
		theSong.SetTempo(dlgTempo.m_nTempo);
	RebuildDisplay();
	ASSERT (m_pPage != 0);
	m_pPage->EnableUndo();
}
void CLeadSheet::SetTitle()
{
	SelectChord(-1);
	ChangeTitle();
	ASSERT (m_pPage != 0);
	m_pPage->EnableUndo();
}
void CLeadSheet::SetKey()
{
	SelectChord(-1);
	if (m_dlgKey.DoModal() == IDOK)	{
		if (m_dlgKey.m_bTranspose)
			theSong.Transpose(m_dlgKey.m_Chord);
		else
			theSong.SetKey(m_dlgKey.m_Chord);
	}
	RebuildDisplay();
	ASSERT (m_pPage != 0);
	m_pPage->EnableUndo();
}
void CLeadSheet::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (!theSong.IsPlaying())	{
		CDC* pDC = GetDC();
		CPoint pt(point);
		pt.y += m_nTopRow;

		ReleaseCapture();

		int nMeasureNo;
		for (nMeasureNo = 0; nMeasureNo < m_nMeasures; nMeasureNo++)
			if (m_Measures[nMeasureNo].PtInRect(pt))
				break;

		if (nMeasureNo < m_nMeasures && IsBlockMarked() && IsMeasureInBlock(nMeasureNo))	{
			SetCapture();
			m_hOldCursor = SetCursor(m_bCtrlDown ? hCtrlDownCursor : hCtrlUpCursor);
			m_bDragging = TRUE;
			SaveBlock();
			return;
		}
		UnmarkBlock();
		m_MousePosition = CPoint(0,0);
		KillTimer(0);
		if (m_TitleRect.PtInRect(pt))
			SetTitle();
		else if (m_TempoRect.PtInRect(pt))
			SetTempo();
		else if (m_KeyRect.PtInRect(pt))
			SetKey();
		else if (m_ClefRect.PtInRect(pt))
			OnClef();
		else	{
			if (!m_PrevRect.IsRectNull())	{
				CRect prc = m_PrevRect;
				prc.top -= m_nTopRow;
				prc.bottom -= m_nTopRow;
				pDC->DrawFocusRect(prc);
				m_PrevRect = CRect(0,0,0,0);
				m_bChordOutlined = FALSE;
			}
			m_bClicked = TRUE;

			if (nMeasureNo < m_nMeasures)	{
				m_nAnchorMeasure = nMeasureNo;
				m_nTerminalMeasure = -1;
				SetCapture();
			}
		}
	}
	SetFocus();
}

void CLeadSheet::OnLButtonUp(UINT nFlags, CPoint point) 
{
	KillTimer(0);
	CDC* pDC = GetDC();
	if (m_bDragging)	{
		if (m_nSelectedMeasure != -1)	{

			int nMeasure = m_nSelectedMeasure;
			SelectMeasure(-1);

			int nStart, nStop, nCount;
			GetBlockMarkers(nStart, nStop, nCount);

			// ---- copy the marked block onto the heap
			int nChords = nCount * m_nChordsPerMeasure;
			Song::Event* pEvents = new Song::Event[nChords];
			for (int nChord = 0; nChord < nChords; nChord++)
				pEvents[nChord] = theSong.GetEvent(nStart * m_nChordsPerMeasure + nChord);

			if (bMoving)	{
				// ---- delete the marked block from the song
				theSong.DeleteMeasures(nStart, nCount);
				UnmarkBlock();
				if (nMeasure > nStart)
					nMeasure -= nCount;
			}

			// ---- paste the saved marked block into the song
			theSong.InsertMeasures(nMeasure, nCount, pEvents, FALSE);
			delete [] pEvents;

			BuildSong();
			if (bCopying)
				RestoreBlock();
			SelectMeasure(nMeasure);
			Invalidate();
		}
		ReleaseCapture();
		m_bDragging = FALSE;
		ASSERT (m_pPage != 0);
		m_pPage->EnableUndo();
		SetCursor(m_hOldCursor);
	}
	else if (m_bMarking)	{
		SelectChord(pDC, -1);
		SelectMeasure(pDC, -1);
		m_bMarking = FALSE;
		ReleaseCapture();
		m_MousePosition = CPoint(0,0);
		ASSERT (m_pPage != 0);
		m_pPage->EnableRepeats();
	}
	else if (m_bClicked)	{
		m_bClicked = FALSE;
		m_nAnchorMeasure = -1;
		ASSERT (m_pPage != 0);
		m_pPage->DisableCutCopy();
		ReleaseCapture();
		m_MousePosition = CPoint(0,0);
		CPoint pt(point);
		pt.y += m_nTopRow;
		int i;

		for (i = 0; i < theSong.ChordCount(); i++)	{
			if (m_Chords[i].PtInRect(pt))	{
				m_bChordOutlined = TRUE;
				m_nOutlinedChord = i;
				if (i == m_nSelectedChord)	{
					// --- clicked a selected chord (or double-clicked a chord)
					const CChord& chord = theSong.GetChord(i);
					CChord newChord = m_CDlgSelectChord.GetChord(chord);
					if (newChord.root != 0)	{
						m_Chord = newChord;
						ProcessChord();
					}
				}
				else	{
					SelectChord(pDC, m_nOutlinedChord);
					SelectMeasure(pDC, m_nOutlinedChord / m_nChordsPerMeasure);
				}
				break;
			}
		}
		if (i == theSong.ChordCount())	{
			i /= m_nChordsPerMeasure;
			SelectChord(pDC, -1);
			if (m_Measures[i].PtInRect(pt))
				SelectMeasure(pDC, i);
			else
				SelectMeasure(pDC, -1);
		}	
	}
	SetFocus();
}

void CLeadSheet::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == 0)
		OnMouseMove(0, m_MousePosition);
	else if (m_Chord.root != 0)
		ProcessChord();
}
void CLeadSheet::OnInsert()
{
	if (m_nSelectedMeasure != -1)	{
		int nMeasures = 1;

		if (m_bCtrlDown)	{
			m_bCtrlDown = FALSE;
			CDlgInsertMeasures dlgMeasures;
			if (dlgMeasures.DoModal() != IDOK)
				return;
			nMeasures = dlgMeasures.m_nMeasureCount;
		}

		if (nMeasures + theSong.ChordCount() > maxchords)
			AfxMessageBox("Cannot insert; too many measures", MB_ICONSTOP);
		else	{
			int nEvents = m_nChordsPerMeasure * nMeasures;

			Song::Event* pEvent = new Song::Event[nEvents];

			CChord chord = m_nSelectedMeasure == 0 ? theSong.m_Key : 
					theSong.GetEvent(m_nSelectedMeasure * m_nChordsPerMeasure - 1).m_Chord;

			for (int i = 0; i < nEvents; i++)
				pEvent[i].m_Chord = chord;

			theSong.InsertMeasures(m_nSelectedMeasure, nMeasures, pEvent, TRUE);
			delete [] pEvent;
			BuildSong();
			Invalidate();
			ASSERT (m_pPage != 0);
			m_pPage->EnableUndo();
		}
	}
}
void CLeadSheet::OnClear()
{
	int nStart, nStop, nCount;
	GetBlockMarkers(nStart, nStop, nCount);
	theSong.DeleteMeasures(nStart, nCount);
	UnmarkBlock();
	m_nSelectedMeasure = -1;
	m_nSelectedChord = -1;
	BuildSong();
	Invalidate();
	ASSERT (m_pPage != 0);
	m_pPage->DisablePaste();
}
void CLeadSheet::OnCut()
{
	OnCopy();
	OnClear();
}
void CLeadSheet::OnCopy()
{
	if (IsBlockMarked())	{
		int nStart, nStop, nCount;
		GetBlockMarkers(nStart, nStop, nCount);
		nStart *= m_nChordsPerMeasure;
		nStop *= m_nChordsPerMeasure;
		nCount *= m_nChordsPerMeasure;
		delete [] m_pClipboardEvents;
		m_pClipboardEvents = new Song::Event[nCount];
		for (int nChord = 0; nChord < nCount; nChord++)
			m_pClipboardEvents[nChord] = theSong.GetEvent(nStart + nChord);
		ASSERT(m_nChordsPerMeasure);
		m_nClipboardCount = nCount / m_nChordsPerMeasure;
		ASSERT (m_pPage != 0);
		m_pPage->EnablePaste();
	}
/*
	else	{
		// --- no block marked, paste the song image to the Windows clipboard
		HBITMAP hBitmap = *m_pCBitmap;
		if (OpenClipboard())	{
			EmptyClipboard();
			SetClipboardData(CF_BITMAP, hBitmap);
			CloseClipboard();
		}
	}
*/
}
void CLeadSheet::OnPaste()
{
	if (m_nClipboardCount != 0)	{
		int nStart, nStop, nCount;
		GetBlockMarkers(nStart, nStop, nCount);
		if (m_nClipboardCount - nCount + theSong.ChordCount() > maxchords)
			AfxMessageBox("Cannot paste; too many measures", MB_ICONSTOP);
		else	{
			int nMeasure = m_nSelectedMeasure;
			BOOL bStophere = TRUE;
			if (m_nAnchorMeasure != -1)	{
				nMeasure = nStart;
				OnClear();
				bStophere = FALSE;
			}
			if (nMeasure != -1)	{
				theSong.InsertMeasures(nMeasure, m_nClipboardCount, m_pClipboardEvents, bStophere);
				BuildSong();
				Invalidate();
				UpdateWindow();
				SelectChord(nMeasure * m_nChordsPerMeasure);
			}
		}
	}
}
void CLeadSheet::OnPrint()
{
	PRINTDLG printDlg = {
		sizeof(PRINTDLG),
		0,
		0,
		0,
		0,
		PD_RETURNDC | PD_USEDEVMODECOPIES | PD_NOSELECTION
	};
	if (PrintDlg(&printDlg))	{

		CDC* pPrinterDC = CDC::FromHandle(printDlg.hDC);

		if (pPrinterDC->GetDeviceCaps(TECHNOLOGY) != DT_RASPRINTER)	{
			AfxMessageBox("Graphics printer required", MB_ICONSTOP);
			return;
		}
		if ((pPrinterDC->GetDeviceCaps(RASTERCAPS) & RC_STRETCHBLT) == 0)	{
			AfxMessageBox("Cannot print to this device", MB_ICONSTOP);
			return;
		}

		CWaitCursor wait;

		DOCINFO DocInfo = {
			sizeof(DOCINFO),
			theSong.m_strTitle,
			0
		};

		if (pPrinterDC->StartDoc(&DocInfo) != -1)	{
			int nPageno = 1, nPage, pagey = 0;
			pPrinterDC->StartPage();
			PrintSong(pPrinterDC, nPageno, nPage, pagey);
			BottomOfPage(pPrinterDC, nPageno);
			pPrinterDC->EndDoc();
		}
	}
}

const int scalefactor = 60;
const int srctitleht = 28;

void CLeadSheet::BottomOfPage(CDC* pPrinterDC, int& nPageno)
{
	int phinch = pPrinterDC->GetDeviceCaps(LOGPIXELSY);	// pixels per inch, height
	int pheight = pPrinterDC->GetDeviceCaps(VERTRES);	// page height
	int pwidth  = pPrinterDC->GetDeviceCaps(HORZRES);	// page width

	CString strPageNo;
	strPageNo.Format("%d", nPageno++);

	CSize size = pPrinterDC->GetTextExtent(strPageNo);

	int x = (pwidth - size.cx) / 2;
	int y = pheight - srctitleht * (phinch / scalefactor);

	// ---- print the page number
	pPrinterDC->TextOut(x, y, strPageNo);

	pPrinterDC->EndPage();

}

void CLeadSheet::PrintSong(CDC* pPrinterDC, int& nPageno, int& n1stPageno, int& pagey)
{
	int pwinch = pPrinterDC->GetDeviceCaps(LOGPIXELSX);	// pixels per inch, width
	int phinch = pPrinterDC->GetDeviceCaps(LOGPIXELSY);	// pixels per inch, height
	int pheight = pPrinterDC->GetDeviceCaps(VERTRES);	// page height
	int npgno = 0;

	CRect rc;
	GetClientRect(&rc);

	int wd = rc.Width() * (pwinch / scalefactor);

	int srcstaffht = (staffheight + staffpadding);
	int staffht = srcstaffht * (phinch / scalefactor);
	int titleht = srctitleht * (phinch / scalefactor);
	int lmargin = pwinch / 3;	// left margin = 1/3 inch beyond printer's default margin
	int tmargin = phinch / 2;	// top margin = 1/2 inch
	int bmargin = phinch / 2;	// bottom margin = 1/2 inch

	int x1 = lmargin;
	int y1 = titleht + pagey + tmargin;
	int y2 = srctitleht;

	// ---- must be room for at least the title and one staff on the page
	if (y1 >=  pheight - bmargin - staffht - titleht)	{
		BottomOfPage(pPrinterDC, nPageno);
		pPrinterDC->StartPage();
		pagey = 0;
		y1 = titleht + tmargin;
	}

	// ----- number of staffs left on this page
	int nStaffsPage = (pheight - tmargin - bmargin - pagey - titleht) / staffht;

	// --- post the starting page number to caller
	n1stPageno = nPageno;

	// ---- display the title and tempo, first page, this song
	pPrinterDC->StretchBlt(lmargin, pagey + tmargin, wd, titleht, m_pCDC, 0, 0, rc.Width(), srctitleht, SRCCOPY);

	int i;

	do {
		for (i = 0; i < nStaffsPage && y2 < m_nBottomRow; i++)	{
			if (!pPrinterDC->StretchBlt(x1,					// x
										y1 + i * staffht,	// y
										wd,					// width
										staffht,			// height
										m_pCDC, 
										0,					// x
										y2,					// y
										rc.Width(),			// width
										srcstaffht,			// height
										SRCCOPY))	{
				AfxMessageBox("Error printing on this device", MB_ICONSTOP);
				return;
			}
			y2 += srcstaffht;
		}

		if (y2 < m_nBottomRow)	{
			BottomOfPage(pPrinterDC, nPageno);
			pPrinterDC->StartPage();
			// ---- display the title, pages 2 and up

			CFont* pOldFont = m_pCDC->SelectObject(&theApp.m_TitleFont);
			CString strTitle;
			// ---- rebuild the title with a page number appended
			strTitle.Format("%s (cont'd: %d)", theSong.m_strTitle.GetBuffer(0), ++npgno);
			CSize size = m_pCDC->GetTextExtent(strTitle);
			int x = (m_SongRect.Width() - size.cx) / 2;
			CRect TitleRect = CRect(x, 2, x + size.cx, 2 + size.cy);
			// --- put the new title into the display bitmap
			m_pCDC->TextOut(x, 2, strTitle);

			// ---- print the title
			pPrinterDC->StretchBlt(lmargin, tmargin, wd, titleht/2, m_pCDC, 0, 0, rc.Width(), srctitleht/2, SRCCOPY);
			y1 = titleht + tmargin;

			// ---- reset the title to its original value (without the page number)
			m_pCDC->FillRect(&TitleRect, theApp.m_pClearBrush);
			size = m_pCDC->GetTextExtent(theSong.m_strTitle);
			x = (m_SongRect.Width() - size.cx) / 2;
			m_pCDC->TextOut(x, 2, theSong.m_strTitle);
			
			m_pCDC->SelectObject(pOldFont);
			nStaffsPage = (pheight - titleht) / staffht;
		}

	} while (y2 < m_nBottomRow);
	pagey = y1 + i * staffht;
}
void CLeadSheet::GetBlockMarkers(int& rStart, int& rStop, int& rCount) const
{
	rStart = m_nAnchorMeasure;
	rStop = m_nTerminalMeasure;
	if (rStart > rStop)	{
		int temp = rStart;
		rStart = rStop;
		rStop = temp;
	}
	rCount = rStart != -1 ? (rStop-rStart+1) : 0;
}

void CLeadSheet::OnStyle()
{
	CStyleDlg dlg;
	Song::Style nStyle = theSong.CurrentStyle(m_nSelectedMeasure);
	dlg.m_nStyle = theSong.ButtonFromStyle(nStyle);
	if (dlg.DoModal() == IDOK)	{
		Song::Style nNewStyle = theSong.StyleFromButton(dlg.m_nStyle);
		if (nNewStyle != nStyle)	{
			theSong.SetStyle(m_nSelectedMeasure, nNewStyle);
			RebuildDisplay();
		}
	}
}

void CLeadSheet::TestKeyboardMarking()
{
	if (!m_bKeyboardMarking)	{
		UnmarkBlock();
		m_bKeyboardMarking = TRUE;
		m_nAnchorMeasure = m_nSelectedMeasure == -1 ? 0 : m_nSelectedMeasure;
		m_nTerminalMeasure = -1;
	}
}

void CLeadSheet::NextChord()
{
	int nChord = m_nSelectedChord;
	if (m_bCtrlDown || m_bShiftDown)	{
		while (++nChord % m_nChordsPerMeasure)
			;
		--nChord;
	}
	if (nChord < m_nMeasures * m_nChordsPerMeasure - 1)	{
		if (m_bShiftDown)	{
			TestKeyboardMarking();
			AdjustBlockDisplay(++m_nSelectedMeasure);
		}
		SelectChord(nChord + 1);
	}
	else if (!m_bShiftDown)
		SelectMeasure(m_nMeasures);
	if (CanPaste())
		m_pPage->EnablePaste();
}
void CLeadSheet::PreviousChord()
{
	int nChord = m_nSelectedChord;
	if (m_bCtrlDown || m_bShiftDown)	{
		if (nChord == 0 && !m_bShiftDown)
			nChord = m_nMeasures * m_nChordsPerMeasure;
		if (nChord > 0)	{
			while (--nChord % m_nChordsPerMeasure)
				;
			nChord++;
		}
	}
	if (nChord > 0)	{
		if (m_bShiftDown)	{
			TestKeyboardMarking();
			if (m_nSelectedMeasure > 0)
				AdjustBlockDisplay(--m_nSelectedMeasure);
			else
				AdjustBlockDisplay(0);
		}
		SelectChord(nChord - 1, FALSE);
	}
	else if (!m_bShiftDown)
		SelectChord(m_nMeasures * m_nChordsPerMeasure - 1, FALSE);
	if (CanPaste())
		m_pPage->EnablePaste();
}
void CLeadSheet::LowerChord()
{
	int nChord = m_nSelectedChord;
	if (nChord < 0)
		nChord = 0;
	int nP = nChord;
	// --- find the next lower row of chords
	do
		nP++;
	while (nP < m_nMeasures * m_nChordsPerMeasure && m_Beats[nChord].y == m_Beats[nP].y);

	int px;
	int py = m_Beats[nP].y;
	do	{
		px = m_Beats[nP++].x;
		if (m_Beats[nP].y != py)	{
			--nP;
			if (m_bShiftDown)	{
				TestKeyboardMarking();
				AdjustBlockDisplay(nP / m_nChordsPerMeasure);
			}
			SelectChord(nP);
			if (CanPaste())
				m_pPage->EnablePaste();
			return;
		}
	}
	while (nP < m_nMeasures * m_nChordsPerMeasure && m_Beats[nP].x < m_Beats[nChord].x);

	if (nP < m_nMeasures * m_nChordsPerMeasure)	{
		if (m_Beats[nP].x - m_Beats[nChord].x  >  m_Beats[nChord].x - m_Beats[nP-1].x)
			--nP;
		if (m_bShiftDown)	{
			TestKeyboardMarking();
			AdjustBlockDisplay(nP / m_nChordsPerMeasure);
		}
		SelectChord(nP);
	}
	if (CanPaste())
		m_pPage->EnablePaste();
}
void CLeadSheet::UpperChord()
{
	int nChord = m_nSelectedChord;

	if (m_Beats[nChord].y <= topmargin + staffpadding + 5)
		return;

	if (nChord < 0)
		nChord = 0;
	int nP = nChord - 1;
	// --- find the next upper row of chords
	while (nP > 0 && m_Beats[nChord].y == m_Beats[nP].y)
		--nP;

	int px = -1;
	int py = m_Beats[nP].y;
	while (nP > 0 && m_Beats[nP].x > m_Beats[nChord].x)	{
		px = m_Beats[--nP].x;
		if (m_Beats[nP].y != py)	{
			nP++;
			if (m_bShiftDown)	{
				TestKeyboardMarking();
				AdjustBlockDisplay(nP / m_nChordsPerMeasure);
			}
			SelectChord(nP, FALSE);
			if (CanPaste())
				m_pPage->EnablePaste();
			return;
		}
	}

	if (nP >= 0)	{
		if (px > -1 && m_Beats[nP+1].x - m_Beats[nChord].x  <  m_Beats[nChord].x - m_Beats[nP].x)
			nP++;
		if (m_bShiftDown)	{
			TestKeyboardMarking();
			AdjustBlockDisplay(nP / m_nChordsPerMeasure);
		}
		SelectChord(nP, FALSE);
	}
	if (CanPaste())
		m_pPage->EnablePaste();
}
void CLeadSheet::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (theSong.IsPlaying())
		return;

	ASSERT (m_pPage != 0);

	switch (nChar)	{
		case VK_RETURN:
		case VK_SPACE:
			m_pPage->DoPlayback();
			return;
		case VK_INSERT:
			OnInsert();
			return;
		case VK_DELETE:
			if (IsBlockMarked())
				OnClear();
			else if (m_nSelectedChord != -1)	{
				theSong.DeleteChord(m_nSelectedChord);
				BuildSong();
				Invalidate();
			}
			m_pPage->EnableUndo();
			return;
		default:
			break;
	}

	char key = toupper(nChar);
	if (m_bCtrlDown)	{
		switch (key)	{
			case VK_CONTROL:
				return;
			case 'R':
				OnAbbreviated();
				return;
			case 'B':
				OnClef();
				return;
			case 'X':
				OnCutCmd();
				return;
			case 'C':
				OnCopyCmd();
				return;
			case 'V':
				OnPasteCmd();
				return;
			case 'Z':
				OnUndoCmd();
				return;
			case 'N':
				OnNewCmd();
				return;
			case 'O':
				OnOpenCmd();
				return;
#ifndef DEMO_VERSION
			case 'S':
				OnSaveCmd();
				return;
			case 'A':
				OnSaveasCmd();
				return;
#endif
			case 'M':
				OnBuildmidifileCmd();
				return;
			case 'P':
				OnPrintCmd();
				return;

			default:
				break;
		}
	}
	else	{

		switch (nChar)	{
			case VK_CONTROL:
				m_bCtrlDown = TRUE;
				if (m_bDragging)
					SetCursor(hCtrlDownCursor);
				return;
			case VK_SHIFT:
				m_bShiftDown = TRUE;
				return;
			default:
				break;
		}
	}

	if (!m_bShiftDown && IsBlockMarked())
		UnmarkBlock();

	switch (nChar)	{
		case VK_RIGHT:
			NextChord();
			return;
		case VK_LEFT:
			PreviousChord();
			return;
		default:
			break;
	}
	if (!m_bCtrlDown)	{
		switch (nChar)	{
			case VK_DOWN:
				LowerChord();
				return;
			case VK_UP:
				UpperChord();
				return;
			case VK_NEXT:
				PageDown();
				return;
			case VK_PRIOR:
				PageUp();
				return;
			case VK_HOME:
				ScrollTo(0);
				return;
			case VK_END:
			{
				int nto = m_nBottomRow - pagesize;
				if (nto > 0)
					ScrollTo(nto);
				return;
			}
			default:
				break;
		}

		if (key >= 'A' && key <= 'G')	{
			if (m_nSelectedChord != -1)	{
				CChord newChord = m_CDlgSelectChord.GetChord(key);
				if (newChord.root != 0)	{
					m_Chord = newChord;
					ProcessChord();
				}
			}
			return;
		}
		switch (key)	{
			case 'T':
				// --- set tempo
				SetTempo();
				break;
			case 'K':
				// --- set key signature
				SetKey();
				break;
			case 'L':
				// --- set title
				SetTitle();
				break;
			case 'S':
				if (m_nSelectedMeasure != -1)
					OnStyle();
				break;
			default:
				break;
		}
	}
}

void CLeadSheet::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (nChar == VK_CONTROL)	{
		m_bCtrlDown = FALSE;
		if (m_bDragging)
			SetCursor(hCtrlUpCursor);
	}
	else if (nChar == VK_SHIFT)
		m_bShiftDown = FALSE;
}

// ------ these overrides intercept what the base CEdit class wants to do
void CLeadSheet::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
}
BOOL CLeadSheet::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	SetCursor(m_hArrowCursor);
	return TRUE;
}
void CLeadSheet::OnSetFocus(CWnd* pOldWnd) 
{
	m_bHasFocus = TRUE;
	Invalidate();
}
void CLeadSheet::OnKillFocus(CWnd* pNewWnd) 
{
	m_bHasFocus = FALSE;
	Invalidate();
}

void CLeadSheet::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CMenu menu;
	VERIFY(menu.LoadMenu(IDR_CONTEXTMENU));
	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);

	if (!IsBlockMarked())	{
		pPopup->EnableMenuItem(IDC_CUT,  MF_DISABLED | MF_GRAYED);
//		pPopup->EnableMenuItem(IDC_COPY, MF_DISABLED | MF_GRAYED);
	}
	if (!CanPaste())
		pPopup->EnableMenuItem(IDC_PASTE, MF_DISABLED | MF_GRAYED);

	if (!theSong.IsUndoDataStored())	{
		pPopup->EnableMenuItem(IDC_UNDO, MF_DISABLED | MF_GRAYED);
		pPopup->EnableMenuItem(IDC_SAVE, MF_DISABLED | MF_GRAYED);
	}

#ifdef DEMO_VERSION
	pPopup->EnableMenuItem(IDC_SAVE,          MF_DISABLED | MF_GRAYED);
	pPopup->EnableMenuItem(IDC_SAVEAS,        MF_DISABLED | MF_GRAYED);
	pPopup->EnableMenuItem(IDC_BUILDMIDIFILE, MF_DISABLED | MF_GRAYED);
#endif

	pPopup->CheckMenuItem(IDC_ABBREVIATED, theOptions.m_nAbbreviated ? MF_CHECKED : MF_UNCHECKED);
	pPopup->CheckMenuItem(IDC_BASSCLEF,    theOptions.m_nClef ? MF_CHECKED : MF_UNCHECKED);

	// ---- display and track the popup menu, sending commands to the lead sheet window
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
}

void CLeadSheet::OnBuildmidifileCmd() 
{
	m_pPage->OnBuildmidifile();
	SetFocus();
}

void CLeadSheet::OnCopyCmd() 
{
	if (IsBlockMarked())
		m_pPage->OnCopy();
}

void CLeadSheet::OnCutCmd() 
{
	if (IsBlockMarked())
		m_pPage->OnCut();
}

void CLeadSheet::OnNewCmd() 
{
	m_pPage->OnNew();
	SetFocus();
}

void CLeadSheet::OnOpenCmd() 
{
	m_pPage->OnOpen();
	SetFocus();
}

void CLeadSheet::OnPasteCmd() 
{
	if (CanPaste())
		m_pPage->OnPaste();
}

void CLeadSheet::OnPrintCmd() 
{
	m_pPage->OnPrint();
	SetFocus();
}

#ifndef DEMO_VERSION
void CLeadSheet::OnSaveCmd() 
{
	if (theSong.IsUndoDataStored())	{
		m_pPage->OnSave();
		SetFocus();
	}
}

void CLeadSheet::OnSaveasCmd() 
{
	m_pPage->OnSaveAs();
	SetFocus();
}
#endif

void CLeadSheet::OnUndoCmd() 
{
	if (theSong.IsUndoDataStored())	{
		UnmarkBlock();
		SelectMeasure(-1);
		theSong.UndoLastAction();
		RebuildDisplay();
	}
}
void CLeadSheet::OnAbbreviated() 
{
	theOptions.m_nAbbreviated ^= 1;
	RebuildDisplay();
}
void CLeadSheet::OnClef()
{
	theOptions.m_nClef ^= 1;
	RebuildDisplay();
}
