// --- midicord.cpp

#include "stdafx.h"
#include "midifitz.h"
#include "midicord.h"

CChord::CChord(const midiChord& rChord)
{
	root = rChord.root;
	attr = 0;
	if (rChord.major)
		attr |= major;
	if (rChord.minor)
		attr |= minor;
	if (rChord.seventh)
		attr |= seventh;
	if (rChord.diminished)
		attr |= diminished;
	if (rChord.augmented)
		attr |= augmented;
	if (rChord.major7)
		attr |= major7;
	if (rChord.flat5)
		attr |= flat5;
}

CChord::operator midiChord()
{
	midiChord crd;
	crd.root = root;
	crd.major      = (attr & major)      != 0;
	crd.minor      = (attr & minor)      != 0;
	crd.seventh    = (attr & seventh)    != 0;
	crd.diminished = (attr & diminished) != 0;
	crd.augmented  = (attr & augmented)  != 0;
	crd.major7     = (attr & major7)     != 0;
	crd.flat5      = (attr & flat5)      != 0;
	return crd;
}
