// --- midicord.h

#ifndef MIDICORD_H
#define MIDICORD_H

struct midiChord {
	char root;
	BOOL major;
	BOOL minor;
	BOOL seventh;
	BOOL diminished;
	BOOL augmented;
	BOOL major7;
	BOOL flat5;
};

struct CChord	{
	char root;			// 2 nybbls: msn = bass note; lsn = chord root
	char attr;
	enum {
		major      = 1,
		minor      = 2,
		seventh    = 4,
		diminished = 8,
		augmented  = 16,
		major7     = 32,
		flat5      = 64
	};
	friend CArchive& operator<<(CArchive& ar, CChord& crd);
	friend CArchive& operator>>(CArchive& ar, CChord& crd);
	CChord()
		{ root = attr = 0; }
	CChord(const midiChord& rmidiChord);
	operator midiChord();
	int operator!=(const CChord& crd)
		{ return root != crd.root || attr != crd.attr; }
	int operator==(const CChord& crd)
		{ return !(*this != crd); }
};

inline CArchive& operator<<(CArchive& ar, CChord& crd)
{
	ar << crd.root;
	ar << crd.attr;
	return ar;
}

inline CArchive& operator>>(CArchive& ar, CChord& crd)
{
	ar >> crd.root;
	ar >> crd.attr;
	return ar;
}

#endif
