// ---- midiDev.h

#ifndef MIDIDEV_H
#define MIDIDEV_H

#include "midifitz.h"
#include "midiin.h"
#include "midiout.h"

// --- abstract bass class for midi devices
class midiDevice	{
protected:
	int m_nDefaultChannel;
	char* m_pDevName;
	int m_nChannel;
	virtual void Initialize();
public:
	midiDevice(char* pDevName, int nChannel);
	virtual ~midiDevice()
		{ }
	virtual void SetChannel(int ch);
	int GetChannel();
	virtual void StopPlaying()
		{ }
	const char* DeviceName() const
		{ return m_pDevName; }
};

inline int midiDevice::GetChannel()
{
	return m_nChannel + 1;
}

#endif
