// ---- midiin.cpp

#include "stdafx.h"
#include "midiin.h"

MidiIn::MidiIn()
{
	m_hWnd = 0;
    hMidiIn = 0;
	currDevice = -1;
    numDevices = midiInGetNumDevs();
}

MidiIn::~MidiIn()
{
	if (hMidiIn != 0)	{
		midiInStop(hMidiIn);
		midiInClose(hMidiIn);
	}
}

void MidiIn::DeviceList(CComboBox* dlist)
{
	ASSERT(dlist != 0);
	MIDIINCAPS icaps;
	for (short int i = 0; i < numDevices; i++)	{
		midiInGetDevCaps(i, &icaps, sizeof(icaps));
		dlist->AddString(icaps.szPname);
	}
}

BOOL MidiIn::ChangeDevice(short int device)
{
	if (device >= numDevices)
		device = numDevices-1;
	ASSERT(m_hWnd != 0);
	if (device != currDevice)	{
		if (hMidiIn)	{
			midiInStop(hMidiIn);
			midiInClose(hMidiIn);
			hMidiIn = 0;
		}
		HMIDIIN hIn;
	    if (midiInOpen(&hIn, device, (DWORD) m_hWnd, 0, CALLBACK_WINDOW) != 0)	{
			currDevice = -1;
			return FALSE;
		}
		hMidiIn = hIn;
		midiInStart(hMidiIn);
		currDevice = device;
	}
	return TRUE;
}
