// ----- midiout.h

#ifndef MIDIOUT_H
#define MIDIOUT_H

#include <vector>
#include <mmsystem.h>

struct OpenDevice	{
	HMIDIOUT hOut;
	int referencecount;
};

class MidiOut	{
	static bool m_bBuildingMidiFile;
	static short int numDevices;
	static std::vector<OpenDevice> devicelist;
	static OpenDevice nulldevice;

	HMIDIOUT hMidiOut;
	short int currDevice;
	DWORD m_dwOrigMidiVolume;
	DWORD m_dwNewMidiVolume;
public:
	MidiOut();
	~MidiOut();
	void DeviceList(CComboBox* dlist);
	void SendEvent(DWORD dwEvent);
	bool ChangeDevice(short int device);
	static void DoMessage(DWORD mmsg);
	static void StartMessage()
		{ DoMessage(0xfa); }
	static void TimingMessage()
		{ DoMessage(0xf8); }
	static void StopMessage()
		{ DoMessage(0xfc); }
	void CloseDevice();
	static void SetBuildingMidiFile(bool bSet)
		{ m_bBuildingMidiFile = bSet; }
};

inline void MidiOut::SendEvent(DWORD dwEvent)
{
	if (hMidiOut != 0 && !m_bBuildingMidiFile)
		midiOutShortMsg(hMidiOut, dwEvent);
}

#endif

