// MidiPage.h : header file
//
#ifndef MIDIPAGE_H
#define MIDIPAGE_H

#include "Page.h"
#include "midicord.h"

/////////////////////////////////////////////////////////////////////////////
// CMidiPage dialog

class midiDevice;

class CMidiPage : public CPage
{
	DECLARE_DYNCREATE(CMidiPage)

	CPen* m_pBlackOffPen;
	CPen* m_pWhiteOffPen;
	CPen* m_pBlackOnPen;
	CPen* m_pWhiteOnPen;

	CChord m_PrevChord;

	void SetPianoPatch();
	void SetDrumsPatch();
	void SetBassPatch();
	void SetGuitarPatch();
	void OnDeltaposInstrumentspin(midiDevice* pmidiDevice, NMHDR* pNMHDR, LRESULT* pResult);
	void DisplayNote(short unsigned note, BOOL bOn);

// Construction
public:
	CMidiPage();
	~CMidiPage();
	BOOL SaveSettings();
	void NoteOn(short unsigned note)
		{ DisplayNote(note, TRUE); }
	void NoteOff(short unsigned note)
		{ DisplayNote(note, FALSE); }
	void InitializeControls();

// Dialog Data
	//{{AFX_DATA(CMidiPage)
	enum { IDD = IDD_MIDI_PAGE };
	CStatic	m_Chord;
	CStatic	m_Keyboard;
	CComboBox	m_PianoDevice;
	CComboBox	m_BassDevice;
	CComboBox	m_GuitarDevice;
	CComboBox	m_DrumsDevice;
	CComboBox	m_InDevice;
	CSpinButtonCtrl	m_KeyboardChannel;
	CSpinButtonCtrl	m_PianoChannel;
	CSpinButtonCtrl	m_DrumsChannel;
	CSpinButtonCtrl	m_BassChannel;
	CSpinButtonCtrl	m_GuitarChannel;
	int		m_nPianoPatch;
	int		m_nDrumsPatch;
	int		m_nBassPatch;
	int		m_nGuitarPatch;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CMidiPage)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CMidiPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeBass();
	afx_msg void OnSelchangeGuitar();
	afx_msg void OnSelchangeDrums();
	afx_msg void OnSelchangePiano();
	afx_msg void OnSelchangeIndevice();
	afx_msg void OnSelchangePianodevice();
	afx_msg void OnSelchangeBassdevice();
	afx_msg void OnSelchangeGuitardevice();
	afx_msg void OnSelchangeDrumsdevice();
	afx_msg void OnDeltaposKeyboardspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposPianospin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposDrumsspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposBassspin(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif
