// OpenDlg.cpp : implementation file
//

#include "stdafx.h"
#include <io.h>
#include "midifitz.h"
#include "OpenDlg.h"
#include "options.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenDlg dialog


COpenDlg::COpenDlg(const CString& strTitle, int id)
	: CDialog(id, 0)
{
	//{{AFX_DATA_INIT(COpenDlg)
	m_strTitle = strTitle;
	//}}AFX_DATA_INIT
}


void COpenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpenDlg)
	DDX_Control(pDX, IDC_SONGLIST, m_SongList);
	DDX_LBString(pDX, IDC_SONGLIST, m_strTitle);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COpenDlg, CDialog)
	//{{AFX_MSG_MAP(COpenDlg)
	ON_WM_CREATE()
	ON_LBN_DBLCLK(IDC_SONGLIST, OnDblclkSonglist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void COpenDlg::BuildSongList()
{
	m_SongList.ResetContent();
	struct _finddata_t fileinfo;
	CString strPath = theOptions.m_strSongPath + "*.sng";

	long hFile = _findfirst(strPath.GetBuffer(0), &fileinfo);

	while (hFile != -1)	{
		CString strName(fileinfo.name);
		m_SongList.AddString(strName.Left(strName.GetLength()-4));
		if (_findnext(hFile, &fileinfo) == -1)
			hFile = -1;
	}
}

/////////////////////////////////////////////////////////////////////////////
// COpenDlg message handlers

BOOL COpenDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	BuildSongList();
	m_SongList.SetCurSel(0);
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int COpenDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style |= LBS_SORT | LBS_HASSTRINGS;
	return CDialog::OnCreate(lpCreateStruct);
}

void COpenDlg::OnDblclkSonglist() 
{
	OnOK();
}
