// ------ options.h

#ifndef OPTIONS_H
#define OPTIONS_H

class COptions	{
public:
	// --- Midi page options
	int m_nMidiInDevice;
	
	int m_nMidiPianoDevice;
	int m_nMidiDrumsDevice;
	int m_nMidiBassDevice;
	int m_nMidiGuitarDevice;

	int m_nPianoPatch;
	int m_nDrumsPatch;
	int m_nBassPatch;
	int m_nGuitarPatch;
	
	int m_nPianoChannel;
	int m_nDrumsChannel;
	int m_nBassChannel;
	int m_nGuitarChannel;
	
	int m_nKeyboardChannel;

	// --- Play page options
	int m_nPianoPlaying;
	int m_nDrumsPlaying;
	int m_nBassPlaying;
	int m_nGuitarPlaying;

	int m_nCountoff;
	int m_nStyle;
	int m_nClef;
	int m_nAbbreviated;

	// --- Settings page options
	int m_nPianoPan;
	int m_nPianoVolume;
	int m_nDrumsPan;
	int m_nDrumsVolume;
	int m_nBassPan;
	int m_nBassVolume;
	int m_nGuitarPan;
	int m_nGuitarVolume;

	BOOL m_bAdjustBass;

	// --- Sets page options
	int m_nSet;
	int m_nSong;

	// --- Master MIDI out device volume
	DWORD m_dwMidiVolume;

	// --- Last song loaded
	CString m_strLastSong;

	// --- Active PropertyPage
	int m_nActivePage;

	// --- Active Song Database Path
	CString m_strSongPath;

	COptions();
	~COptions();
	void LoadOptions();
	int GetChannel(const char* pDevName, int nDefaultChannel) const;
	int GetPatch(const char* pDevName, int nDefaultPatch) const;
	int GetPan(const char* pDevName) const;
	int GetVolume(const char* pDevName) const;
	void SetChannel(const char* pDevName, int nChannel);
	void SetPatch(const char* pDevName, int nPatch);
	void SetPan(const char* pDevName, int nPan);
	void SetVolume(const char* pDevName, int nVolume);
	void SetMasterMidiVolume(DWORD dwMidiVolume)
		{ m_dwMidiVolume = dwMidiVolume; }
	DWORD GetMasterMidiVolume() const
		{ return m_dwMidiVolume; }
};

extern COptions theOptions;

#endif
