// Play.h : header file
//

#ifndef PLAY_H
#define PLAY_H

#include <mmsystem.h>
#include "Page.h"
#include "midicord.h"
#include "song.h"

const int MaxTempo = 280;

class CPlay : public CPage
{
	DECLARE_DYNCREATE(CPlay)

	BOOL m_bCounting;

	int m_nCounting;	// 0 = none; 1 = audio/visual; 2 = visual

	BOOL m_bRecording;
	int m_nTempoCtr;
	int m_nMeasure;
	int m_nBeat;

	DWORD m_dwPrevTime;
	TIMECAPS m_TimeCaps;
	UINT m_nTimer;
	int m_nCountDown;
	int m_nClock;

	CChord m_PrevChord;

	void SetCountOffIcon();
	void SetStyleFromButtons();
	void ComputeExternalTempo();
	void EnableAllStyles();
	void DisableThree();
	void DisableFour();
	void ResetFocus()
		{ m_StartButton.SetFocus();	}
	void DoWaltz();
	void DoFourFour();


// Construction
public:
	CPlay();
	~CPlay();
	BOOL SaveSettings();
	void StartMsg();
	BOOL TimingMsg();
	void StopMsg();
	void PlaySong(int nFirstMeasure, int nLastMeasure);
	void StopSong()
		{ if (theSong.IsPlaying()) OnStartstop(); }
	void BuildMidiFile();

// Dialog Data
	//{{AFX_DATA(CPlay)
	enum { IDD = IDD_PLAY };
	CButton	m_RecordButton;
	CStatic	m_Chord;
	CStatic	m_Beat;
	CButton	m_CountOff;
	CButton	m_StartButton;
	CButton	m_PianoButton;
	CButton	m_DrumsButton;
	CButton	m_BassButton;
	CButton	m_GuitarButton;
	UINT m_nTempo;
	int		m_nStyleButton;
	//}}AFX_DATA

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPlay)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPlay)
	virtual BOOL OnInitDialog();
	afx_msg void OnStartstop();
	afx_msg void OnPianobutton();
	afx_msg void OnDrumsbutton();
	afx_msg void OnBassbutton();
	afx_msg void OnGuitarbutton();
	afx_msg void OnBallad();
	afx_msg void OnBossa();
	afx_msg void OnEasybossa();
	afx_msg void OnShuffle();
	afx_msg void OnDixie();
	afx_msg void OnJazzwaltz();
	afx_msg void OnSwing();
	afx_msg void OnTwobeat();
	afx_msg void OnWaltz();
	afx_msg void OnRock();
	afx_msg void OnCountry();
	afx_msg void OnRockballad();
	afx_msg void OnCount();
	afx_msg void OnRecord();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#endif
