// Sets.h : header file
//
#ifndef SETS_H
#define SETS_H

#include "Page.h"
#include "DlgAddSong.h"
#include "SongListBox.h"

/////////////////////////////////////////////////////////////////////////////
// CSets dialog

class CSets : public CPage
{
	DECLARE_DYNCREATE(CSets)

	void BuildSetList();
	void BuildSongList(int nSong);
	void WriteSongList();
	void InitializeSongPanel();
	void FocusOnList();

// Construction
public:
	CSets();
	~CSets();
	void StartPlaying();
	void StopPlaying();
	void DisplayChord();
	void DisplayBeat();
	void DisplayStyle();
	BOOL OnSetActive();
	BOOL OnKillActive();
	void DoPlayback()
		{ OnPlayback(); }
	BOOL SaveSettings();

// Dialog Data
	//{{AFX_DATA(CSets)
	enum { IDD = IDD_SETS };
	CStatic	m_Style;
	CStatic	m_Beat;
	CStatic	m_Chord;
	CButton	m_Cue;
	CButton	m_Playback;
	CButton	m_Up;
	CButton	m_Down;
	CButton	m_Print;
	CSongListBox	m_SongList;
	CSongListBox	m_SetList;
	CString	m_Key;
	CString	m_Tempo;
	//}}AFX_DATA

#ifdef DEMO_VERSION
	CButton	m_AddSong;
	CButton	m_NewSet;
	CButton	m_DelSong;
	CButton	m_DelSet;
#endif

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSets)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
#ifndef DEMO_VERSION
	afx_msg void OnNewset();
	afx_msg void OnDelset();
	afx_msg void OnAddsong();
	afx_msg void OnDelsong();
	afx_msg void OnDown();
	afx_msg void OnUp();
#endif
	//{{AFX_MSG(CSets)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeSets();
	afx_msg void OnSelchangeSongs();
	afx_msg void OnPlayback();
	afx_msg void OnCue();
	afx_msg void OnDblclkSongs();
	afx_msg void OnPrint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif
