// Sheet.h : header file
//

#ifndef SHEET_H
#define SHEET_H

#include "MidiPage.h"
#include "Settings.h"
#include "Play.h"
#include "SongPage.h"
#include "Sets.h"
#include "About.h"
#include "midicord.h"

/////////////////////////////////////////////////////////////////////////////
// CSheet

class CSheet : public CPropertySheet
{
	CMidiPage m_CMidiPage;
	CSettings m_CSettings;
	CPlay m_CPlay;
	CSongPage m_CSongPage;
	CSets m_CSets;
	CAbout m_CAbout;

	CWnd* m_pExitWnd;

	BOOL m_bExitEnabled;

	LONG OnMIDIMessage(WPARAM, LPARAM msg);

// Construction
public:
	CSheet(LPCTSTR pszCaption);
	void Initialize();
	void StartPlaying();
	void StopPlaying();
	BOOL SaveSettings();
	void PlaySong(int nFirstMeasure = -1, int nLastMeasure = -1)
		{ m_CPlay.PlaySong(nFirstMeasure, nLastMeasure); }
	void StopSong()
		{ m_CPlay.StopSong(); }
	void Beat(int nBeat)
		{ m_CSongPage.Beat(nBeat); }
	void ChordEvent(CChord chord)
		{ m_CSongPage.ChordEvent(chord); }
#ifndef DEMO_VERSION
	BOOL CanExit();
#endif
	void BuildMidiFile()
		{ m_CPlay.BuildMidiFile(); }
	void DisplayChord()
		{ m_CSets.DisplayChord(); }
	void DisplayBeat()
		{ m_CSets.DisplayBeat(); }
	void DisplayCount(BOOL bOnOff)
		{ m_CSongPage.DisplayCount(bOnOff);	}
	void DisplayStyle()
		{ m_CSets.DisplayStyle(); }
	void InitializeControls()
		{ m_CMidiPage.InitializeControls(); }

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSheet)
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSheet();

	// Generated message map functions
protected:
	//{{AFX_MSG(CSheet)
	//}}AFX_MSG
#ifndef DEMO_VERSION
	afx_msg void OnSysCommand(UINT wParam, LPARAM lParam);
#endif
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif
