// SongPage.cpp : implementation file
//

#include "stdafx.h"
#include "midifitz.h"
#include "Sheet.h"
#include "SongPage.h"
#include "LeadSheet.h"
#include "OpenDlg.h"
#include "Options.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSongPage property page

IMPLEMENT_DYNCREATE(CSongPage, CPage)

CSongPage::CSongPage() : CPage(CSongPage::IDD, "Song Page")
{
	//{{AFX_DATA_INIT(CSongPage)
	//}}AFX_DATA_INIT
	m_pCLeadSheet = 0;
	m_psp.dwFlags |= PSP_HASHELP;
}

CSongPage::~CSongPage()
{
	delete m_pCLeadSheet;
}

void CSongPage::DoDataExchange(CDataExchange* pDX)
{
	CPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSongPage)
	DDX_Control(pDX, IDC_NEW, m_New);
	DDX_Control(pDX, IDC_CUE, m_Cue);
	DDX_Control(pDX, IDC_WHOLEREST, m_WholeRest);
	DDX_Control(pDX, IDC_QUARTERREST, m_QuarterRest);
	DDX_Control(pDX, IDC_HALFREST, m_HalfRest);
	DDX_Control(pDX, IDC_BEGINREPEAT, m_BeginRepeat);
	DDX_Control(pDX, IDC_ENDREPEAT, m_EndRepeat);
	DDX_Control(pDX, IDC_PASSAGE, m_Passage);
	DDX_Control(pDX, IDC_SAVE, m_Save);
	DDX_Control(pDX, IDC_BUILDMIDIFILE, m_BuildMidiFile);
	DDX_Control(pDX, IDC_PRINT, m_Print);
	DDX_Control(pDX, IDC_PASTE, m_Paste);
	DDX_Control(pDX, IDC_CUT, m_Cut);
	DDX_Control(pDX, IDC_COPY, m_Copy);
	DDX_Control(pDX, IDC_UNDO, m_Undo);
	DDX_Control(pDX, IDC_OPEN, m_Open);
	DDX_Control(pDX, IDC_PLAYBACK, m_Playback);
	DDX_Control(pDX, IDC_STYLE, m_Style);
	DDX_Control(pDX, IDC_ENDING, m_Ending);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSongPage, CPage)
#ifndef DEMO_VERSION
	ON_BN_CLICKED(IDC_SAVE, OnSave)
#endif
	//{{AFX_MSG_MAP(CSongPage)
	ON_BN_CLICKED(IDC_PLAYBACK, OnPlayback)
	ON_BN_CLICKED(IDC_BEGINREPEAT, OnBeginrepeat)
	ON_BN_CLICKED(IDC_ENDREPEAT, OnEndrepeat)
	ON_BN_CLICKED(IDC_PASSAGE, OnPassage)
	ON_BN_CLICKED(IDC_ENDING, OnEnding)
	ON_BN_CLICKED(IDC_STYLE, OnStyle)
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_BUILDMIDIFILE, OnBuildmidifile)
	ON_BN_CLICKED(IDC_CUE, OnCue)
	ON_BN_CLICKED(IDC_CUT, OnCut)
	ON_BN_CLICKED(IDC_COPY, OnCopy)
	ON_BN_CLICKED(IDC_PASTE, OnPaste)
	ON_BN_CLICKED(IDC_UNDO, OnUndo)
	ON_BN_CLICKED(IDC_QUARTERREST, OnQuarterrest)
	ON_BN_CLICKED(IDC_HALFREST, OnHalfrest)
	ON_BN_CLICKED(IDC_WHOLEREST, OnWholerest)
	ON_BN_CLICKED(IDC_PRINT, OnPrint)
	ON_BN_CLICKED(IDC_NEW, OnNew)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CSongPage::EnableControls(BOOL bEnable)
{
	m_Open.EnableWindow(bEnable);
	m_New.EnableWindow(bEnable);

#ifndef DEMO_VERSION
	m_Save.EnableWindow(bEnable);
	m_BuildMidiFile.EnableWindow(bEnable);
#endif

	m_Print.EnableWindow(bEnable);

	m_BeginRepeat.EnableWindow(bEnable ? (m_pCLeadSheet->CanRepeat()) : FALSE);
	m_EndRepeat.EnableWindow(bEnable   ? (m_pCLeadSheet->CanRepeat()) : FALSE);

	m_QuarterRest.EnableWindow(bEnable ? (m_pCLeadSheet->CanRest()) : FALSE);
	m_HalfRest.EnableWindow(bEnable    ? (m_pCLeadSheet->CanRest()) : FALSE);
	m_WholeRest.EnableWindow(bEnable   ? (m_pCLeadSheet->CanRest()) : FALSE);
	m_Passage.EnableWindow(bEnable     ? (m_pCLeadSheet->CanRest()) : FALSE);

	m_Style.EnableWindow(bEnable  ? (m_pCLeadSheet->CanRest()) : FALSE);
	m_Ending.EnableWindow(bEnable ? (m_pCLeadSheet->CanRest()) : FALSE);

	m_Cut.EnableWindow(bEnable   ? (m_pCLeadSheet->IsBlockMarked()) : FALSE);
	m_Copy.EnableWindow(bEnable  ? (m_pCLeadSheet->IsBlockMarked()) : FALSE);
	m_Paste.EnableWindow(bEnable ? (m_pCLeadSheet->CanPaste()) : FALSE);
	m_Undo.EnableWindow(bEnable  ? (theSong.IsUndoDataStored()) : FALSE);
}
void CSongPage::StartPlaying()
{
	if (m_bIsActive && m_pCLeadSheet != 0)	{
		m_Playback.SetIcon(theApp.m_hStopPlayIcon);
		EnableControls(FALSE);
		m_pCLeadSheet->StartPlaying();
		m_Playback.SetFocus();
		theApp.SetMouse(m_Playback);
	}
}
void CSongPage::StopPlaying()
{
	if (m_bIsActive && m_pCLeadSheet != 0)	{
		m_pCLeadSheet->StopPlaying();
		m_Playback.SetIcon(theApp.m_hPlayIcon);
		EnableControls(TRUE);
		m_Cue.EnableWindow(FALSE);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSongPage message handlers

BOOL CSongPage::OnInitDialog() 
{
	CPage::OnInitDialog();

	m_New.SetIcon(theApp.m_hNewIcon);
	m_Open.SetIcon(theApp.m_hOpenIcon);
	m_Save.SetIcon(theApp.m_hSaveIcon);
	m_BuildMidiFile.SetIcon(theApp.m_hBuildMidiFileIcon);
	m_Cut.SetIcon(theApp.m_hCutIcon);
	m_Copy.SetIcon(theApp.m_hCopyIcon);
	m_Paste.SetIcon(theApp.m_hPasteIcon);
	m_Undo.SetIcon(theApp.m_hUndoIcon);
	m_Print.SetIcon(theApp.m_hPrintIcon);
	m_Playback.SetIcon(theApp.m_hPlayIcon);
	m_BeginRepeat.SetIcon(theApp.m_hBeginRepeatIcon);
	m_EndRepeat.SetIcon(theApp.m_hEndRepeatIcon);
	m_Passage.SetIcon(theApp.m_hPassageIcon);
	m_Style.SetIcon(theApp.m_hStyleIcon);
	m_Ending.SetIcon(theApp.m_hEndingIcon);
	m_QuarterRest.SetIcon(theApp.m_hQuarterRestIcon);
	m_HalfRest.SetIcon(theApp.m_hHalfRestIcon);
	m_WholeRest.SetIcon(theApp.m_hWholeRestIcon);
	m_Cue.SetIcon(theApp.m_hCueIcon);

	m_Cue.EnableWindow(FALSE);
	m_Paste.EnableWindow(FALSE);
	m_Undo.EnableWindow(FALSE);

#ifdef DEMO_VERSION
	m_Save.EnableWindow(FALSE);
	m_BuildMidiFile.EnableWindow(FALSE);
#endif

	DisableCutCopy();
	DisableRests();
	DisableRepeats();
	DisableStyleAndEnding();
	DisableSongButtons();

	m_pCLeadSheet = new CLeadSheet();
	m_pCLeadSheet->Initialize(this);
	m_pCLeadSheet->ShowWindow(SW_SHOW);
	m_Playback.SetFocus();

	return FALSE;
}
BOOL CSongPage::OnSetActive() 
{
	if (m_pCLeadSheet != 0)	{
		m_pCLeadSheet->NewSong();
		m_pCLeadSheet->BuildSong();
		DisablePaste();
	}

	EnableControls(!theSong.IsPlaying());

	if (theSong.ChordCount() != 0)	{
		if (theSong.IsPlaying())	{
			DisableSongButtons();
			m_Playback.SetIcon(theApp.m_hStopPlayIcon);
		}
		else	{
			m_Playback.SetIcon(theApp.m_hPlayIcon);
			EnableSongButtons();
			m_Cue.EnableWindow(FALSE);
		}
	}
	else
		DisableSongButtons();

	m_Playback.SetFocus();

	return CPage::OnSetActive();
}

void CSongPage::OnPlayback() 
{
	if (theSong.IsPlaying())
		m_pCSheet->StopSong();
	else	{
		BOOL bOK = FALSE;
		if (m_pCLeadSheet->IsBlockMarked())
			bOK = TRUE;
		else	{
			unsigned int nEvent;
			CString strErrMsg;
			if (theSong.Validate(nEvent, strErrMsg))
				bOK = TRUE;
			else	{
				m_pCLeadSheet->SelectMeasure(nEvent/theSong.m_nBeatsPerMeasure);
				CString strMsg(strErrMsg + ". Play anyway?");
				bOK = AfxMessageBox(strMsg, MB_ICONQUESTION | MB_YESNO) == IDYES;
			}
		}
		if (bOK)
			m_pCSheet->PlaySong(m_pCLeadSheet->FirstMeasure(), m_pCLeadSheet->LastMeasure());
	}
}
#ifndef DEMO_VERSION
BOOL CSongPage::SaveSong(BOOL bExiting)
{
	int nRtn = IDYES;
	if (theSong.IsChanged())	{
		nRtn = AfxMessageBox("Song has changed. Save it?", MB_YESNOCANCEL);
		if (nRtn == IDYES)
			OnSave();
		else if (bExiting)
			theSong.ResetChanged();
	}
	return (nRtn != IDCANCEL);
}
#endif
BOOL CSongPage::OnKillActive() 
{
#ifndef DEMO_VERSION
	if (!SaveSong(FALSE))
		return FALSE;
#endif
	theSong.ResetChanged();
	m_pCLeadSheet->UnmarkBlock();
	return CPage::OnKillActive();
}
void CSongPage::OnBeginrepeat() 
{
	m_pCLeadSheet->ToggleBeginRepeat();
	m_pCLeadSheet->SetFocus();
	EnableUndo();
}
void CSongPage::OnEndrepeat() 
{
	m_pCLeadSheet->ToggleEndRepeat();
	m_pCLeadSheet->SetFocus();
	EnableUndo();
}
void CSongPage::OnPassage() 
{
	m_pCLeadSheet->TogglePassage();
	m_pCLeadSheet->SetFocus();
	EnableUndo();
}
void CSongPage::OnEnding() 
{
	m_pCLeadSheet->ToggleEnding();
	m_pCLeadSheet->SetFocus();
	EnableUndo();
}
void CSongPage::OnOpen() 
{
	CFileDialog dlg(TRUE,
					"sng",
					theSong.m_strTitle,
					OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST,
					"MidiFitz Song Files (*.sng)|*.sng||",
					this
					);

	if (dlg.DoModal() == IDOK)	{
#ifndef DEMO_VERSION
		if (SaveSong(FALSE))
#endif
		{

			theOptions.m_strSongPath = dlg.GetPathName();
			int nIndex = theOptions.m_strSongPath.ReverseFind('\\');
			if (nIndex > 0)
				theOptions.m_strSongPath = theOptions.m_strSongPath.Left(nIndex+1);

			m_pCLeadSheet->NewSong();
			CString strTitle = dlg.GetFileName();
			if (theSong.LoadSong(strTitle.Left(strTitle.GetLength()-4)))	{
				m_pCLeadSheet->RebuildDisplay();
				EnableSongButtons();
			}
			DisablePaste();
		}
	}
	EnableUndo();
	m_Playback.SetFocus();
}
#ifndef DEMO_VERSION
void CSongPage::OnSave() 
{
	while (theSong.m_strTitle == Song::m_strDefaultTitle)
		if (m_pCLeadSheet->ChangeTitle() == FALSE)
			return;
	theSong.SaveSong();
	EnableUndo();
	m_Playback.SetFocus();
}
void CSongPage::OnSaveAs() 
{
	while (theSong.m_strTitle == Song::m_strDefaultTitle)
		if (m_pCLeadSheet->ChangeTitle() == FALSE)
			return;
	CFileDialog dlg(FALSE,
					"sng",
					theSong.m_strTitle,
					OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"MidiFitz Song Files (*.sng)|*.sng||",
					this
					);

	if (dlg.DoModal() == IDOK)	{
		theOptions.m_strSongPath = theSong.m_strTitle = dlg.GetPathName();
		int nIndex = theOptions.m_strSongPath.ReverseFind('\\');
		if (nIndex != -1)
			theOptions.m_strSongPath = theOptions.m_strSongPath.Left(nIndex+1);
		else
			theOptions.m_strSongPath.Empty();
		CString strTitle = theSong.m_strTitle.Right(theSong.m_strTitle.GetLength() - (nIndex+1));
		strTitle = strTitle.Left(strTitle.GetLength() - 4);
		if (strTitle != theSong.m_strTitle)	{
			theSong.m_strTitle = strTitle;
			m_pCLeadSheet->RebuildDisplay();
		}
		theSong.SaveSong();
		EnableUndo();
	}
	m_Playback.SetFocus();
}
#endif
void CSongPage::OnBuildmidifile() 
{
	m_pCSheet->BuildMidiFile();
	m_Playback.SetFocus();
}
void CSongPage::OnCue() 
{
	theSong.Cue();
	m_Cue.EnableWindow(FALSE);
	m_pCLeadSheet->SetFocus();
}
void CSongPage::OnCut() 
{
	m_pCLeadSheet->OnCut();
	EnableUndo();
	m_pCLeadSheet->SetFocus();
}
void CSongPage::OnCopy() 
{
	m_pCLeadSheet->OnCopy();
	m_pCLeadSheet->SetFocus();
}
void CSongPage::OnPaste() 
{
	m_pCLeadSheet->OnPaste();
	EnableUndo();
	m_pCLeadSheet->SetFocus();
}
void CSongPage::OnUndo() 
{
	m_pCLeadSheet->OnUndo();
	EnableUndo();
	m_pCLeadSheet->SetFocus();
}
void CSongPage::OnQuarterrest()
{
	m_pCLeadSheet->ToggleQuarterRest();
	EnableUndo();
	m_pCLeadSheet->SetFocus();
}
void CSongPage::OnHalfrest()
{
	m_pCLeadSheet->ToggleHalfRest();
	EnableUndo();
	m_pCLeadSheet->SetFocus();
}
void CSongPage::OnWholerest()
{
	m_pCLeadSheet->ToggleWholeRest();
	EnableUndo();
	m_pCLeadSheet->SetFocus();
}

void CSongPage::OnPrint() 
{
	m_pCLeadSheet->OnPrint();
	m_Playback.SetFocus();
}
void CSongPage::OnStyle() 
{
	m_pCLeadSheet->OnStyle();
	EnableUndo();
	m_pCLeadSheet->SetFocus();
}
BOOL CSongPage::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if (wParam == ID_ENABLECUE)	{
		m_Cue.EnableWindow();
		m_Cue.SetFocus();
		return TRUE;
	}
	return CPage::OnCommand(wParam, lParam);
}

void CSongPage::OnNew() 
{
#ifndef DEMO_VERSION
	if (SaveSong(FALSE))
#endif
	{
		m_pCLeadSheet->NewSong();
		theSong.BuildDummySong();
		m_pCLeadSheet->RebuildDisplay();
		EnableSongButtons();
		DisablePaste();
	}
	m_pCLeadSheet->SetFocus();
}

