// SongPage.h : header file
//

#ifndef SONGPAGE_H
#define SONGPAGE_H

/////////////////////////////////////////////////////////////////////////////
// CSongPage dialog

#include "Page.h"
#include "LeadSheet.h"

class CSongPage : public CPage
{
	friend CLeadSheet;

	CLeadSheet* m_pCLeadSheet;

	DECLARE_DYNCREATE(CSongPage)

	void EnableControls(BOOL bEnable);

// Construction
public:
	CSongPage();
	~CSongPage();
	void StartPlaying();
	void Beat(int nBeat)
		{ if (m_bIsActive && m_pCLeadSheet != 0) m_pCLeadSheet->Beat(nBeat); }
	void DisplayCount(BOOL bOnOff)
		{ if (m_bIsActive && m_pCLeadSheet != 0) m_pCLeadSheet->Countoff(bOnOff); }
	void ChordEvent(CChord chord)
		{ if (m_bIsActive && m_pCLeadSheet != 0) m_pCLeadSheet->ChordEvent(chord); }
	void StopPlaying();
	void EnableCutCopy()
		{ m_Cut.EnableWindow(); m_Copy.EnableWindow(); }
	void DisableCutCopy()
		{ m_Cut.EnableWindow(FALSE); m_Copy.EnableWindow(FALSE); }
	void EnablePaste()
		{ m_Paste.EnableWindow(); }
	void DisablePaste()
		{ m_Paste.EnableWindow(FALSE); }
	void EnableRests()
	{
		m_WholeRest.EnableWindow();
		m_QuarterRest.EnableWindow();
		m_HalfRest.EnableWindow();
	}
	void EnableUndo()
	{
		m_Undo.EnableWindow(theSong.IsUndoDataStored());
#ifndef DEMO_VERSION
		m_Save.EnableWindow(theSong.CanSave());
#endif
	}
	void EnableSongButtons()
	{
#ifndef DEMO_VERSION
		m_Save.EnableWindow(theSong.CanSave());
		m_BuildMidiFile.EnableWindow();
#endif
		m_Print.EnableWindow();
//		m_Playback.EnableWindow();
	}
	void DisableSongButtons()
	{
		m_Save.EnableWindow(FALSE);
		m_BuildMidiFile.EnableWindow(FALSE);
		m_Print.EnableWindow(FALSE);
//		m_Playback.EnableWindow(FALSE);
	}
	void EnableStyleAndEnding()
	{
		m_Style.EnableWindow();
		m_Ending.EnableWindow();
		m_Passage.EnableWindow();
	}
	void DisableStyleAndEnding()
	{
		m_Style.EnableWindow(FALSE);
		m_Ending.EnableWindow(FALSE);
		m_Passage.EnableWindow(FALSE);
	}
	void DisableRests()
	{
		m_WholeRest.EnableWindow(FALSE);
		m_QuarterRest.EnableWindow(FALSE);
		m_HalfRest.EnableWindow(FALSE);
	}
	void EnableRepeats()
	{
		m_BeginRepeat.EnableWindow();
		m_EndRepeat.EnableWindow();
	}
	void DisableRepeats()
	{
		m_BeginRepeat.EnableWindow(FALSE);
		m_EndRepeat.EnableWindow(FALSE);
	}
#ifndef DEMO_VERSION
	BOOL SaveSong(BOOL bExiting);
#endif

	void DoPlayback()
		{ OnPlayback(); }

// Dialog Data
	//{{AFX_DATA(CSongPage)
	enum { IDD = IDD_SONGPAGE };
	CButton	m_New;
	CButton	m_Cue;
	CButton	m_WholeRest;
	CButton	m_QuarterRest;
	CButton	m_HalfRest;
	CButton	m_BeginRepeat;
	CButton	m_EndRepeat;
	CButton	m_Passage;
	CButton	m_Save;
	CButton	m_BuildMidiFile;
	CButton	m_Print;
	CButton	m_Paste;
	CButton	m_Cut;
	CButton	m_Copy;
	CButton	m_Undo;
	CButton	m_Open;
	CButton	m_Playback;
	CButton m_Style;
	CButton m_Ending;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSongPage)
	public:
	virtual BOOL OnSetActive();
	virtual BOOL OnKillActive();
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
#ifndef DEMO_VERSION
	afx_msg void OnSave();
	afx_msg void OnSaveAs();
#endif	
	// Generated message map functions
	//{{AFX_MSG(CSongPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnPlayback();
	afx_msg void OnBeginrepeat();
	afx_msg void OnEndrepeat();
	afx_msg void OnPassage();
	afx_msg void OnEnding();
	afx_msg void OnStyle();
	afx_msg void OnOpen();
	afx_msg void OnBuildmidifile();
	afx_msg void OnCue();
	afx_msg void OnCut();
	afx_msg void OnCopy();
	afx_msg void OnPaste();
	afx_msg void OnUndo();
	afx_msg void OnQuarterrest();
	afx_msg void OnHalfrest();
	afx_msg void OnWholerest();
	afx_msg void OnPrint();
	afx_msg void OnNew();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif
