// ----- undo.cpp

#include "stdafx.h"
#include "undo.h"

UndoData::UndoData() : m_nCurrentUndo(0), m_nUndoCount(0), m_bUndoing(false)
{
	for (int i = 0; i < maxUndos; i++)
		m_pUndoNode[i] = 0;
}
UndoData::~UndoData()
{
	DeleteAllUndoActions();
}
void UndoData::DeleteAllUndoActions()
{
	while (m_nCurrentUndo > 0)	{
		delete m_pUndoNode[--m_nCurrentUndo];
		m_pUndoNode[m_nCurrentUndo] = 0;
		--m_nUndoCount;
	}
	if (m_nUndoCount)	{
		m_nCurrentUndo = maxUndos;
		while (m_nUndoCount-- > 0)	{
			delete m_pUndoNode[--m_nCurrentUndo];
			m_pUndoNode[m_nCurrentUndo] = 0;
		}
	}
	m_nCurrentUndo = 0;
	m_bUndoing = false;
}
void UndoData::AddUndoNode(UndoNode* pUndoNode)
{
	if (m_nCurrentUndo == maxUndos)
		m_nCurrentUndo = 0;
	delete m_pUndoNode[m_nCurrentUndo];
	m_pUndoNode[m_nCurrentUndo++] = pUndoNode;
	if (m_nUndoCount < maxUndos)
		m_nUndoCount++;
}
void UndoData::UndoLastAction()
{
	if (m_nUndoCount)	{
		m_bUndoing = true;
		bool bAnchor = true;
		do	{
			if (m_nCurrentUndo == 0)
				m_nCurrentUndo = maxUndos;
			m_pUndoNode[--m_nCurrentUndo]->Undo();
			bAnchor = m_pUndoNode[m_nCurrentUndo]->Anchor();
			delete m_pUndoNode[m_nCurrentUndo];
			m_pUndoNode[m_nCurrentUndo] = 0;
			--m_nUndoCount;
		} while (bAnchor == false && m_nUndoCount > 0);
		m_bUndoing = false;
	}
}
