// ------- midOutDv.h

#ifndef MIDOUTDV_H
#define MIDOUTDV_H

#include "mididev.h"
#include "CMFEvents.h"

class midiOutDevice	: public midiDevice {
	int m_nDefaultPatch;
	CMFEvents* m_pCMFEvents;
protected:
	MidiOut* m_pMidiOut;
	int m_nPatch;
	int m_nVolume;
	int m_nPan;
public:
	midiOutDevice(char* pDevName, int nChannel, int nPatch, MidiOut* pMidiOut, BOOL bRecord = TRUE);
	virtual ~midiOutDevice()
		{ delete m_pCMFEvents; }

	virtual void Initialize();
	void SetChannel(int ch);
	void SetPatch(int vc);
	void SetVolume(int vol);
	void SetPan(int pan);

	void SetPatch()
		{ SetPatch(m_nPatch); }
	void SetVolume()
		{ SetVolume(m_nVolume); }
	void SetPan()
		{ SetPan(m_nPan); }

	int GetVolume() const
		{ return m_nVolume; }
	int GetPan() const
		{ return m_nPan; }
	int GetPatch() const
		{ return m_nPatch; }

	virtual void NoteOn(int note, int velocity);
	void NoteOff(int note, int velocity);
	void ControllerChange(int controller, int velocity);
	int EventCount() const
		{ return m_pCMFEvents ? m_pCMFEvents->EventCount() : 0; }
	DWORD MidiEvent(int nEventNo) const
		{ return m_pCMFEvents ? m_pCMFEvents->MidiEvent(nEventNo) : 0; }
	DWORD Clock(int nEventNo) const
		{ return m_pCMFEvents ? m_pCMFEvents->Clock(nEventNo) : 0; }
};

#endif